/*************************************************************************
* gui.c                                                                  *
* Maupatz     2001                                                       *
* taztv is free software; you can redistribute it and/or modify          *
* it under the terms of the GNU General Public License as published by   *
* the Free Software Foundation; either version 2 of the License, or      *
* (at your option) any later version.                                    *
*                                                                        *
* Taztv is distributed in the hope that it will be useful,               *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
* GNU General Public License for more details.                           *
*                                                                        *
* You should have received a copy of the GNU General Public License      *
* along with this program; if not, write to the Free Software            *
*                                                                        *
*************************************************************************/

#include <string.h>
#include "gui.h"

Display         *gDisplay=0;
Window          Video_window=0;
char skin_name[32]="default";
ImlibData      *gImlib_data=0;



/************skin *****************/

int set_skin_name(char *s) {

   if (s[0]==0) return -1;
   strcpy(skin_name,s);
   return 0;
}

char * get_skin_name(char *s) {

 if (s!=NULL) strcpy(s,skin_name);
 return skin_name;

}


int init_gui(Display *d, Window w){

  gDisplay=d;
  Video_window=w;

  /*
   * init imlib
   */

  gImlib_data   = Imlib_init(gDisplay);

  return 0;
}

int end_gui(void){
    return 0;
}

/*
 * Function for Loading Images, using ImLib
 */

gui_image_t *gui_load_image(const char *image)
{
  ImlibImage *img = NULL;
  gui_image_t *i;

  i = (gui_image_t *) xmalloc(sizeof(gui_image_t));

  if( !( img = Imlib_load_image(gImlib_data, (char *)image) ) ) {
	  fprintf(stderr, "xine-panel: couldn't find image %s\n", image);
    	  exit(-1);
  }

  Imlib_render (gImlib_data, img, img->rgb_width, img->rgb_height);

  i->image  = Imlib_copy_image(gImlib_data, img);
  i->width  = img->rgb_width;
  i->height = img->rgb_height;

  return i;
}
