/*********************************************************************************
 *                                                                               *
 * MeuhMeuh.cpp                                                                  *
 *                                                                               *
 * Copyright (C) 2000/2002 Fasouil                                               *
 *                                                                               *
 *                                                                               *
 * This program is free software; you can redistribute it and/or                 *
 * modify it under the terms of the GNU General Public License                   *
 * as published by the Free Software Foundation; either version 2                *
 * of the License, or (at your option) any later version.                        *
 *                                                                               *
 *                                                                               *          
 * This program is distributed in the hope that it will be useful,               *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                 *
 * GNU General Public License for more details.                                  *
 *                                                                               *
 *                                                                               *
 * You should have received a copy of the GNU General Public License             *
 * along with this program; if not, write to the Free Software                   *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.    *
 * Or, point your browser to http://www.gnu.org/copyleft/gpl.html                *
 *                                                                               *
 *                                                                               *
 * The author can be reached at fasouil@hotmail.com                              *
 *********************************************************************************/ 



#include <stdio.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/time.h>
#include <fcntl.h>
#include <unistd.h>

#include "tinyxml/tinyxml.h"
#include "Structures.h"
#include "LaVache.h"
#include "AjustParam.h"
#include "pluginvideo.h"


//////////////////////////////////////////////////////////////////////////////////


static QuenotteTV_VideoPlugin VideoPlugin;		//instance of KTV_VideoPlugin object


static CLaVache *           pLaVache=NULL;                  //class
static CAjustParam *        pAjustParam=NULL;    //class

// static bool bLoadImage=false;
static bool bSaveImage=false;
static bool bDetectSignalOver=false;

static bool bInitFile=false;
static float fCpuUsed=0;
static __int64 nReferTime=0;
// Ces 2 paramtres sont  rgler ????!!!
// -1 autodfinition
static int nTestNormalUser=-1;
static int nTestPreviousUser=-1;
////////////////////
static bool bWait=false;
static float fLevelSignalDetect=1;
static bool bFullField=true;
static unsigned int nTimeMilliCurrent=0;

static float fGoodPhaseSecam=(float)0.35;
static bool bSpinFilterSecam=true;
static bool bFilterSecam=true;
static bool bFilterPurple=false;
static bool bFilterAverage=false;      // cricri

char File_PossibleNormal[255];
char File_PossiblePrevious[255];
char File_LineNormal[255];
char File_LinePrevious[255];
char File_PurpleKey[255];
char File_ChromiKey[255];
char home_dir[255];

//////////////////////////////////////////////////////////////////////////////////



static int End_MeuhMeuh(void);
static void InitStuff();
static void DoStuff(int bIsOdd, int *pbUpdateBuffer, int *pbViewBuffer);
static void GetStatus(char * Text, int Nb);
static int DetecteSignal(BYTE *VBI);


static __int64 GetRDTSCTime();

static void Attribute_bool(TiXmlElement* itemElement,char * pnom,bool * pbool);
static bool LoadParams(void);
static bool SaveParams(void);
static TiXmlElement* SaveChildElement(TiXmlNode* node,char * cElement);
static TiXmlElement* SaveItemdElement(TiXmlElement* topElement,char * cElement);


//////////////////////////////////////////////////////////////////////////////////

__int64  timeGetTime(void) /* ms */
{
   struct   timeval tv;
   gettimeofday(&tv, NULL);
   return ((__int64)tv.tv_sec * 1000LL + (__int64) (tv.tv_usec / 1000) );
}

static void DoFPC(void)
{
	if(pAjustParam)
	{
          pAjustParam->SetParams(nTestNormalUser,nTestPreviousUser,bFilterSecam,bFilterPurple, bFilterAverage,bFullField);
	  pAjustParam->BuildFPC((void *) 0);
          pAjustParam->GetParams(nTestNormalUser,nTestPreviousUser,bFilterSecam,bFilterPurple,bFilterAverage,bFullField);	
          pLaVache->SetParams(nTestNormalUser,nTestPreviousUser,bFilterSecam,bFilterPurple, bFilterAverage);
          SaveParams();
          bInitFile=true;
	}
}

extern "C"
{

int get_meuhmeuh_filtersecam(void)
{
  return bFilterSecam;
}
void set_meuhmeuh_filtersecam(int value)
{
 bFilterSecam=value;
 bInitFile=true;
}

int get_meuhmeuh_filterpurple(void)
{
 return  bFilterPurple;
}
void set_meuhmeuh_filterpurple(int value)
{
 bFilterPurple=value;
 bInitFile=true;
}

int get_meuhmeuh_filteraverage(void)
{
 return bFilterAverage;
}

void set_meuhmeuh_filteraverage(int value)
{
 bFilterAverage=value;
 bInitFile=true;
}

int toggle_meuhmeuh_filtersecam(void)
{
 bFilterSecam=!bFilterSecam;
 bInitFile=true;
 return bFilterSecam;
}

int toggle_meuhmeuh_filterpurple(void)
{
 bFilterPurple=!bFilterPurple;
 bInitFile=true;
 return  bFilterPurple;
}

int toggle_meuhmeuh_filteraverage(void)
{
 bFilterAverage=!bFilterAverage;
 bInitFile=true;
 return bFilterAverage;
}

// Ne fait pas : nTestNormalUser nTestPreviousUser il faudrait faire un thread pour gnrer
// Fait confiance au calcul par defaut

// init KTV_VideoPlugin instance
QuenotteTV_VideoPlugin *init_mm_Plugin(char *user_dir)
{
       bool bInitOK=false;
       char m_dir[255];

       // Directories
       strcpy(m_dir,user_dir);
       strcpy(home_dir,user_dir);
       strcat(m_dir,"/");
       strcat(m_dir,PLUGIN_SUBDIR);

       strcpy(File_PossibleNormal,m_dir);
       strcat(File_PossibleNormal,"PossibleNormal.fpc");

       strcpy(File_PossiblePrevious,m_dir);
       strcat(File_PossiblePrevious,"PossiblePrevious.fpc");

       strcpy(File_LineNormal,m_dir);
       strcat(File_LineNormal,"LineNormal.fpc");

       strcpy(File_LinePrevious,m_dir);
       strcat(File_LinePrevious,"LinePrevious.fpc");

       strcpy(File_PurpleKey,m_dir);
       strcat(File_PurpleKey,"Purple.fpc");

       strcpy(File_ChromiKey,m_dir);
       strcat(File_ChromiKey,"Chromi.fpc");

	//create class
	pLaVache=new CLaVache();
	if (!pLaVache)
		return FALSE;

	pAjustParam=new CAjustParam();
	if (!pAjustParam)
		return FALSE;

	//load params
	//bFilterPurple=(VideoPlugin.bIsBT878!=0);

	//set plugin params
	VideoPlugin.version = VIDEO_PLUGIN_VERSION;
	VideoPlugin.description = "MeuhMeuhPlug 1.31";	//version

	VideoPlugin.MovieBoost=0;
	VideoPlugin.Full_Field=(bFullField!=0);

	VideoPlugin.InitStuff=InitStuff;
	VideoPlugin.DoStuff=DoStuff;

	VideoPlugin.Stop=End_MeuhMeuh;

        VideoPlugin.GetStatus=GetStatus;
        VideoPlugin.DetecteSignal=DetecteSignal;

        //load params
        bInitOK=LoadParams();
        if (!bInitOK) { SaveParams(); bInitOK=LoadParams(); }
        pLaVache->Init();               //init LaVache variables
        pLaVache->SetParams(nTestNormalUser,nTestPreviousUser,bFilterSecam,bFilterPurple, bFilterAverage);
        bInitOK&=pLaVache->IsInit();

        if (!bInitOK) {
                         mkdir(home_dir,S_IRWXU);
                         mkdir(m_dir,S_IRWXU);
                         DoFPC();
                      }

        nReferTime=GetRDTSCTime();
        nTimeMilliCurrent=timeGetTime();

        return &VideoPlugin;
}
}

static int End_MeuhMeuh(void)
{
        //SaveParams
        SaveParams();

        pLaVache->Destroy();    //destroy LaVache variables

        fLevelSignalDetect=0;   //set off plugin

        return TRUE;
}


static void InitStuff()
{
        nReferTime=GetRDTSCTime();
        nTimeMilliCurrent=timeGetTime();
}

//main process
static void DoStuff(int bIsOdd, int *pbUpdateBuffer, int *pbViewBuffer)
{
	__int64 nTimeCurrent=GetRDTSCTime();
	__int64 nDeltaTime=nTimeCurrent-nReferTime;
	nReferTime=nTimeCurrent;

	int nCurrentFrame = VideoPlugin.CurrentFrame;
	int nPreviousFrame=nCurrentFrame-1;
	if (nPreviousFrame<0)
		nPreviousFrame+=VideoPlugin.NbBuff;

	 *pbUpdateBuffer = FALSE;
	 *pbViewBuffer = bIsOdd;

	//set CurrentX param
	pLaVache->SetSizeBuffer(VideoPlugin.CurrentX,CURRENTY);
	pLaVache->SetHeightBlackBorder(VideoPlugin.MovieBoost);

	//must init LaVache variables (happen after AjustParamDlg)
	if (bInitFile)
	{
		bInitFile=false;
		pLaVache->Destroy();
		pLaVache->Init();
		pLaVache->SetParams(nTestNormalUser,nTestPreviousUser,bFilterSecam,bFilterPurple, bFilterAverage);
                SaveParams();
		return;
	}

	// LaVache not init ?
	if (!pLaVache->IsInit())
	{	//nothing to do
		if(bIsOdd)
			pLaVache->DirectBufferCopy(VideoPlugin.OddLines[nCurrentFrame],VideoPlugin.OutOddLines[nCurrentFrame],bIsOdd);
		else
			pLaVache->DirectBufferCopy(VideoPlugin.EvenLines[nCurrentFrame],VideoPlugin.OutEvenLines[nCurrentFrame],bIsOdd);

		 *pbUpdateBuffer = TRUE;
		return;					//nothing to do
	}
	// LaVache is init!

	//check time
	unsigned int nTimeMilliDelta=timeGetTime()-nTimeMilliCurrent;
	nTimeMilliCurrent=timeGetTime();
        if (nTimeMilliDelta>39)
	{	//nTimeMilliDelta>39 ms !
		pLaVache->LossKeyRepeat();
	}
	//Find key
	if (VideoPlugin.Full_Field)
	{
		//FullField  ----------------------
		if(bIsOdd)
		{
			//save Image (debug)
			if (bSaveImage)
			{
				bSaveImage=false;
				pLaVache->SaveImage(VideoPlugin.OddLines[nCurrentFrame],VideoPlugin.EvenLines[nCurrentFrame]);
			}
			//odd frame
			if (pLaVache->FindKey(VideoPlugin.OddLines[nCurrentFrame],VideoPlugin.OutOddLines[nCurrentFrame],bIsOdd,bSpinFilterSecam))
			{	//key found -> be happy happy happy happy happy happy
				fLevelSignalDetect=1;	//key found -> SignalDetect

				//check phase (low pass filter)
				fGoodPhaseSecam=(fGoodPhaseSecam*(float)5.0+(float)(pLaVache->GetPhase()^bSpinFilterSecam))/(float)6.0;

				*pbUpdateBuffer = TRUE;
			}
			else if (*(VideoPlugin.OutEvenLines[nCurrentFrame]))
			{
				pLaVache->DirectBufferCopy(VideoPlugin.OutEvenLines[nCurrentFrame],VideoPlugin.OutOddLines[nCurrentFrame],bIsOdd);
				*pbUpdateBuffer = TRUE;
			}

			//toggle SpinFilterSecam each image (2 frames)
			bSpinFilterSecam=!bSpinFilterSecam;

			//check Secam phase filter
			if (fGoodPhaseSecam<0.25)
			{
				fGoodPhaseSecam=1.0;
				bSpinFilterSecam=!bSpinFilterSecam;		//toggle secam phase filter
			}
		}
		else
		{
			//Even frame
			if (pLaVache->FindKey(VideoPlugin.EvenLines[nCurrentFrame],VideoPlugin.OutEvenLines[nCurrentFrame],bIsOdd,!bSpinFilterSecam))
			{
				*pbUpdateBuffer = TRUE;	//key found -> be happy happy happy happy happy happy
			}
		        else if (*(VideoPlugin.OutOddLines[nPreviousFrame]))
			{
				pLaVache->DirectBufferCopy(VideoPlugin.OutOddLines[nPreviousFrame],VideoPlugin.OutEvenLines[nCurrentFrame],bIsOdd);
				*pbUpdateBuffer = TRUE;
			}
		}
	}
	else
	{
		//HalfField  ----------------------
		if(bIsOdd)
		{
			//toggle SpinFilterSecam each image
			bSpinFilterSecam=!bSpinFilterSecam;

			//use EvenLines but K!TV send bIsOdd
			//bug -> send (!bIsOdd) to LaVache
			if (pLaVache->FindKey(VideoPlugin.EvenLines[nCurrentFrame],VideoPlugin.OutEvenLines[nCurrentFrame],!bIsOdd,bSpinFilterSecam))
			{	//key found -> be happy happy happy happy happy happy
				fLevelSignalDetect=1;	//key found -> SignalDetect

				//check phase (low pass filter)
				fGoodPhaseSecam=(fGoodPhaseSecam*(float)5.0+(float)(pLaVache->GetPhase()^bSpinFilterSecam))/(float)6.0;

				*pbUpdateBuffer = TRUE;
			}

			//check Secam phase filter
			if (fGoodPhaseSecam<0.25)
			{
				fGoodPhaseSecam=1.0;
				bSpinFilterSecam=!bSpinFilterSecam;		//toggle secam phase filter
			}

			//update input buffer
			pLaVache->UpdateInputLine(VideoPlugin.OddLines[nCurrentFrame],bIsOdd);
			pLaVache->RecordKeyRepeat(true,0);
		}
		 else
		{
			//nothing to do
			*pbUpdateBuffer = FALSE;
		}
	}
	//wait (debug)
	if (bWait)
	{
		bWait=false;
		Sleep(41);		//debug
	}

	//calcul CpuUsed
	__int64 nTimeProcess=GetRDTSCTime()-nTimeCurrent;
	if (nDeltaTime>0)
	{
		float fCpuCurrent=(float)nTimeProcess*100/(float)nDeltaTime;

		//average (low pass filter)
		fCpuUsed=(fCpuUsed*(float)80.0+fCpuCurrent)/(float)81.0;
		if (fCpuUsed>100)
			fCpuUsed=100;
	}
}


//satut bar
static void GetStatus(char * Text, int Nb)
{
        char s[128];
        sprintf(s,"");

        if (Nb)
        {
                sprintf(s,"MeuhMeuhPlug  CPU %.2f%%",fCpuUsed);
                //sprintf(s,"MeuhMeuhPlug  %d",pLaVache->GetHeightBlackDynam());
                
                strcpy(Text, s);        
        }

        strcpy(Text, s);
}



/////////////////////////////////////////////////////////////////////////////
//
// DetecteSignal is based on Albator Plugin
// Thanks Grincheux !
/////////////////////////////////////////////////////////////////////////////
static int DetecteSignal(BYTE *pVBI)
{
        if (bDetectSignalOver)
                return TRUE;
        
        float fSignalDetect=0;
        int i,j,row;
        int text_lines_found=FALSE;
        static int retval;
        unsigned char vbiline[2048];
        unsigned char vbibits[2048/4];
        unsigned char vbibytes[2048/4/8];
        int AutoID_Offset=4;
        unsigned int AutoID_sample_bits[48]=
        {
         0,7,15,23,31,39,47,55,63,71,79,87,95,103,
         111,119,126,134,142,150,158,166,174,182,
         190,198,206,214,222,230,238,245,
         253,261,269,277,285,293,301,309,317,325,
         333,341,349,357,364,372
        };

        //no valid VBI signal
        if (pVBI == NULL)
                fSignalDetect=0;
        else
        {

                text_lines_found=FALSE;

                for(row=0; row<32; row++)
                {
                        for (i=0;i<2048;i++)
                        {
                        if (*(pVBI++) < 95) vbiline[i]=0;
                                else vbiline[i]=1;
                        }
                        i=0;
                        while (vbiline[i]!=1) 
                                if (i++ > 2048) break;
                        if (i>200) continue;
                        for (j=0;j<48 ;j++) vbibits[j]=vbiline[AutoID_sample_bits[j]+AutoID_Offset+i];

                        for (i=0;i<48;i+=8)
                        {
                                vbibytes[i/8]=0;
                                for (j=0;j<8;j++) vbibytes[i/8]|=vbibits[i+j]<<j;  // inverse order
                        }
                        if (vbibytes[0]==0x55) text_lines_found=TRUE;
                        if ((vbibytes[0]==0x55) && (vbibytes[4]==0x15))
                        {
                                if  (vbibytes[5]&0x20)
                                {
                                        retval = TRUE;
                                        break;
                                }
                                else retval = FALSE;
                        }
                }
                if ( text_lines_found == FALSE ) retval=FALSE;
        }

        if (retval)
                fSignalDetect=1;

        fLevelSignalDetect=(fLevelSignalDetect*5.0+fSignalDetect)/6.0;

        if (fLevelSignalDetect>0.5)
                return TRUE;
        else
                return FALSE;

}


static __int64 GetRDTSCTime()
{
    union 
        {
          __int64 ll;
          struct { int lo;int hi ;} s;
        } time;

          __asm__ __volatile__ (
                "cpuid                       \n\t"
                "rdtsc                       \n\t"
                "movl %%eax, %0              \n\t"
                "movl %%edx, %1              \n\t"

           : // FIXASM: output regs/vars go here, e.g.:  "=m" (memory_var)

           : // FIXASM: input regs, e.g.:  "c" (count), "S" (src), "D" (dest)
            "m" (time.s.lo), "m" (time.s.hi)

           : // FIXASM: clobber list, e.g.:  "%eax", "%ecx", "cc"
            "%eax", "%edx","memory"
        );

        return time.ll;
}



static bool LoadParams(void)
{ 
        bool bResult = false;
        char load_dir [255];

        strcpy (load_dir,home_dir);
        strcat (load_dir,"/MeuhMeuhPlug.xml");
        TiXmlDocument doc(load_dir);

        if (doc.LoadFile())
        {
                if (!doc.Error())
                {
                        bResult = true;

                        TiXmlNode* node = NULL;
                        TiXmlElement* topElement = NULL;
                        TiXmlElement* itemElement = NULL;

                        node = doc.FirstChild( "MeuhMeuhPlug" );

                        if (node != NULL)
                        {
                                topElement = node->ToElement();
                                std::string version = *topElement->Attribute("version");

                                // image  --------------------------------------
                                topElement = node->FirstChildElement("Image");

                                if (topElement != NULL)
                                {
                                        // nTestNormalUser
                                        itemElement = topElement->FirstChildElement("TestNormalUser");
                                        if (itemElement != NULL)
                                                itemElement->Attribute("value",&nTestNormalUser);

                                        // nTestPreviousUser
                                        itemElement = topElement->FirstChildElement("TestPreviousUser");
                                        if (itemElement != NULL)
                                                itemElement->Attribute("value",&nTestPreviousUser);

                                        // bDetectSignalOver
                                        itemElement = topElement->FirstChildElement("DetectSignalOver");
                                        if (itemElement != NULL)
                                                Attribute_bool(itemElement,"boolean",&bDetectSignalOver);

                                        // bFullField
                                        itemElement = topElement->FirstChildElement("FullField");
                                        if (itemElement != NULL)
                                                Attribute_bool(itemElement,"boolean",&bFullField);

                                        // Filters
                                        itemElement = topElement->FirstChildElement("Filters");
                                        if (itemElement != NULL)
                                        {
                                                Attribute_bool(itemElement,"FilterSecam",&bFilterSecam);
                                                Attribute_bool(itemElement,"FilterPurple",&bFilterPurple);
                                                Attribute_bool(itemElement,"FilterAverage",&bFilterAverage);
                                        }
                                }
                        }
                }
        }

        return bResult;
}

static void Attribute_bool(TiXmlElement* itemElement,char * pnom,bool * pbool)
{
        int pbooltemp=0;

        itemElement->Attribute(pnom,&pbooltemp);
        *pbool=pbooltemp!=0;

}


static bool SaveParams(void)
{
        bool bResult=false;
        TiXmlNode* node = NULL;
        TiXmlElement* topElement = NULL;
        TiXmlElement* itemElement = NULL;

        const char* MeuhMeuhPlug_Start = 
                "<?xml version=\"1.0\" >\n"
                "<MeuhMeuhPlug version=\"1.0\">\n"              
                "</MeuhMeuhPlug>";

        char save_dir [255];

        strcpy (save_dir,home_dir);
        strcat (save_dir,"/MeuhMeuhPlug.xml");

        //create document
        TiXmlDocument doc(save_dir);

        //load document
        bResult=doc.LoadFile();

        if ((!bResult)||(doc.Error()))
        {       //error
                doc.Parse( MeuhMeuhPlug_Start );
        }


        node = doc.FirstChild( "MeuhMeuhPlug" );
        if (node != NULL)
        {
                bResult = true;
        
                topElement = node->ToElement();
                topElement->SetAttribute("version","1.31");             //version

                // image // topElement ------------------------------
                topElement=SaveChildElement(node,"Image");

                // nTestNormalUser
                itemElement=SaveItemdElement(topElement,"TestNormalUser");
                itemElement->SetAttribute("value",nTestNormalUser);

                // nTestPreviousUser
                itemElement=SaveItemdElement(topElement,"TestPreviousUser");
                itemElement->SetAttribute("value",nTestPreviousUser);

                // bDetectSignalOver
                itemElement=SaveItemdElement(topElement,"DetectSignalOver");
                itemElement->SetAttribute("boolean",bDetectSignalOver);

                //bFullField
                itemElement=SaveItemdElement(topElement,"FullField");
                itemElement->SetAttribute("boolean",bFullField);

                // Filtre
                itemElement=SaveItemdElement(topElement,"Filters");
                itemElement->SetAttribute("FilterSecam",bFilterSecam);
                itemElement->SetAttribute("FilterPurple",bFilterPurple);
                itemElement->SetAttribute("FilterAverage",bFilterAverage);

        }
        else
                bResult=false;

        doc.SaveFile();

        return bResult;
}


static TiXmlElement* SaveChildElement(TiXmlNode* node,char * cElement)
{
        TiXmlElement* topElement = NULL;
        
        topElement = node->FirstChildElement(cElement);
        if (topElement == NULL)
        {
                topElement = new TiXmlElement(cElement);
                node->InsertEndChild(*topElement);
                topElement = node->FirstChildElement(cElement);
        }

        return (topElement);
}

static TiXmlElement* SaveItemdElement(TiXmlElement* topElement,char * cElement)
{
        TiXmlElement* itemElement = NULL; 

        itemElement = topElement->FirstChildElement(cElement);
        if (itemElement == NULL)
        {
                itemElement = new TiXmlElement(cElement);
                topElement->InsertEndChild(*itemElement);
                itemElement = topElement->FirstChildElement(cElement);
        }

        return (itemElement);
}


