/////////////////////////////////////////////////////////////////////////////
// PluginVideo.h
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2000-2002 Quenotte  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//	This file is subject to the terms of the GNU General Public License as
//	published by the Free Software Foundation.  A copy of this license is
//	included with this software distribution in the file COPYING.  If you
//	do not have a copy, you may obtain a copy by writing to the Free
//	Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	This software is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
//
// This software was based on MultiDec 5.9 Those portions are
// Copyright (C) 1999/2000 Espresso (echter_espresso@hotmail.com)
//
/////////////////////////////////////////////////////////////////////////////
#ifndef VIDEOPLUGIN
#define VIDEOPLUGIN




// version actuelle du plugin
#define VIDEO_PLUGIN_VERSION	1011


//////////////////////////////////////////////////////////////////////////////////
// Structure utilise pour communiquer avec le plugin
// Pour plus de dtails voir K!TV et le code du plugin test.
//
// Remarques sur les variables (R/W):
// W : le plugin doit donner une valeur  cette variable.
// R : le plugin ne doit pas modifier cette variable (lecture seule).
// RW: la variable peut etre modifie par le plugin et par K!TV.
//////////////////////////////////////////////////////////////////////////////////

#ifdef __cplusplus
extern "C" {
#endif

typedef struct
{
	int			version;		// W: Version du plugin  (= VIDEO_PLUGIN_VERSION)
	char		*description;	// W: Format obligatoire : nom_du_plugin espace (nom_de_l_auteur)

	int     Full_Field;	// R: Affichage simple (HF) ou double (FF) trame
                                // Curieux le compilateur refuse FullField ??????

	int  bIsBT878;				// R: La carte TV est un BT878

	int CurrentX;				// R: Largeur actuelle de la trame capture
	int CurrentFrame;			// R: Trame courante (pour acceder aux *EvenLines)
	int MovieBoost;				// R: Acclration pour mode 16/9 (bandes noires)

	int NbBuff;                             // nombre de buffer avec Linux
	short *EvenLines[64][288], *OddLines[64][288];			// Lignes captures
	short *OutEvenLines[64][288], *OutOddLines[64][288];		// Lignes  afficher

	// Fonctions de controle
	int  (*Start)();
	int  (*Stop)();

	// Fonctions lis au thread d'affichage
	void (*InitStuff)();
	void (*DoStuff)(int bIsOdd, int *UpdateBuffer, int *ViewBuffer);
	void ( *CheckStuff)();

	// Fonctions de l'interface utilisateur
        void (*ShowDialog)();

	// Diverses fonctions
	void (*GetStatus)(char * Text, int Nb);
        int  (*DetecteSignal)(unsigned char *VBI);

} QuenotteTV_VideoPlugin;

#ifdef __cplusplus
}
#endif

#endif
