/*************************************************************************
* imscaling.c                                                            *
* Maupatz   Xshm by Keuleu   2001                                        *
* taztv is free software; you can redistribute it and/or modify          *
* it under the terms of the GNU General Public License as published by   *
* the Free Software Foundation; either version 2 of the License, or      *
* (at your option) any later version.                                    *
*                                                                        *
* Taztv is distributed in the hope that it will be useful,               *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
* GNU General Public License for more details.                           *
*                                                                        *
* You should have received a copy of the GNU General Public License      *
* along with this program; if not, write to the Free Software            *
*                                                                        *
*************************************************************************/

#include "taztv.h"
#include "imscaling.h"
#include "yuyv2rgb.h"

static int ttc[8];
static int attc[8];
static int  ntc=0;
static int cp;
static int sh_dst=0;
static int sh_src=0;

void PutImageRGB32 (char *dst,int w_dst, int h_dst, char **src, int w_src, int h_src, int xoffset)
{
      int ys,yd;
      int count;
      char *psrc;
      char *pdst;

      int w_size_dst = w_dst << 2;


      psrc = src[0];
      pdst = dst;


      if (h_dst>=h_src) /* agrandissement */
      {
          if ((sh_dst!=h_dst) || (sh_src!=h_src)){

	   cp = h_dst /  h_src; /* nombre fois pour copier la ligne principale */
           yd = h_src * cp;
           /* fait une curieuse approximation h_dst en fonction de h_src */
           memset(ttc,0,sizeof(ttc));
           ntc=0;
           count = 2;
           while (yd < h_dst ){
                       while ((yd + h_src / count) > h_dst ) count ++;
                       yd += h_src / count;
                       ttc[ntc] = count;
                       ntc++;
           }
           sh_dst=h_dst; sh_src=h_src;
                      }

           for (count=0; count < ntc; count ++) attc[count]=ttc[count];

           yd=0;

	   for (ys=0; ys < h_src; ys++)
	    {
              psrc = src[ys];
              putlineYUY2toRGB32(pdst, w_dst, psrc + xoffset, w_src);
              pdst += w_size_dst;
              yd ++;
              if (yd>=h_dst) return;

              for (count=0; count < (cp - 1); count ++) {
                                  memcpy (pdst, pdst - w_size_dst, w_size_dst);
                                  pdst += w_size_dst;
                                  yd ++;
                                  if (yd>=h_dst) return;
              }

              /* fait l'interpolation */
             for (count=0;count<ntc;count++) {
              attc[count]--;
	      if (attc[count] == 0 )
		{
                 attc[count]=ttc[count];
                 memcpy (pdst, pdst - w_size_dst, w_size_dst);
                 pdst += w_size_dst;
                 yd ++;
                 if (yd>=h_dst) return;
                }		
	      }
            }
       }
 else /* plus petit */
       {
          sh_src=0;
	  count = h_src >> 1;
	  for (ys=0; ys < h_src; ys++)
	    {
              psrc = src[ys];
	      count += h_dst;
	      if (count >= h_src)
		{ 		
		  putlineYUY2toRGB32(pdst, w_dst, psrc + xoffset, w_src);
		  count -= h_src;
		  pdst += w_size_dst;
		}
	
	    }
	}

}

void PutImageRGB16 (char *dst,int w_dst, int h_dst, char **src, int w_src, int h_src, int xoffset)
{
     int ys,yd;
      int count;
      char *psrc;
      char *pdst;

      int w_size_dst = w_dst << 1;

      psrc = src[0];
      pdst = dst;

      if (h_dst>=h_src) /* agrandissement */
      {
          if ((sh_dst!=h_dst) || (sh_src!=h_src)){

	   cp = h_dst /  h_src; /* nombre fois pour copier la ligne principale */
           yd = h_src * cp;
           /* fait une curieuse approximation h_dst en fonction de h_src */
           memset(ttc,0,sizeof(ttc));
           ntc=0;
           count = 2;
           while (yd < h_dst ){
                       while ((yd + h_src / count) > h_dst ) count ++;
                       yd += h_src / count;
                       ttc[ntc] = count;
                       ntc++;
           }
           sh_dst=h_dst; sh_src=h_src;
                      }

           for (count=0; count < ntc; count ++) attc[count]=ttc[count];

           yd=0;

	   for (ys=0; ys < h_src; ys++)
	    {
              psrc = src[ys];
              putlineYUY2toRGB16(pdst, w_dst, psrc + xoffset, w_src);
              pdst += w_size_dst;
              yd ++;
              if (yd>=h_dst) return;

              for (count=0; count < (cp - 1); count ++) {
                                  memcpy (pdst, pdst - w_size_dst, w_size_dst);
                                  pdst += w_size_dst;
                                  yd ++;
                                  if (yd>=h_dst) return;
              }

              /* fait l'interpolation */
             for (count=0;count<ntc;count++) {
              attc[count]--;
	      if (attc[count] == 0 )
		{
                 attc[count]=ttc[count];
                 memcpy (pdst, pdst - w_size_dst, w_size_dst);
                 pdst += w_size_dst;
                 yd ++;
                 if (yd>=h_dst) return;
                }		
	      }
            }
       }
 else /* plus petit */
       {
          sh_src=0;
	  count = h_src >> 1;
	  for (ys=0; ys < h_src; ys++)
	    {
              psrc = src[ys];
	      count += h_dst;
	      if (count >= h_src)
		{ 		
		  putlineYUY2toRGB16(pdst, w_dst, psrc + xoffset, w_src);
		  count -= h_src;
		  pdst += w_size_dst;
		}
	
	    }
	}

}

void PutImageRGB15 (char *dst,int w_dst, int h_dst, char **src, int w_src, int h_src,int xoffset)
{
      int ys,yd;
      int count;
      char *psrc;
      char *pdst;

      int w_size_dst = w_dst << 1;


      psrc = src[0];
      pdst = dst;


      if (h_dst>=h_src) /* agrandissement */
      {
          if ((sh_dst!=h_dst) || (sh_src!=h_src)){

	   cp = h_dst /  h_src; /* nombre fois pour copier la ligne principale */
           yd = h_src * cp;
           /* fait une curieuse approximation h_dst en fonction de h_src */
           memset(ttc,0,sizeof(ttc));
           ntc=0;
           count = 2;
           while (yd < h_dst ){
                       while ((yd + h_src / count) > h_dst ) count ++;
                       yd += h_src / count;
                       ttc[ntc] = count;
                       ntc++;
           }
           sh_dst=h_dst; sh_src=h_src;
                      }

           for (count=0; count < ntc; count ++) attc[count]=ttc[count];

           yd=0;

	   for (ys=0; ys < h_src; ys++)
	    {
              psrc = src[ys];
              putlineYUY2toRGB15(pdst, w_dst, psrc + xoffset, w_src);
              pdst += w_size_dst;
              yd ++;
              if (yd>=h_dst) return;

              for (count=0; count < (cp - 1); count ++) {
                                  memcpy (pdst, pdst - w_size_dst, w_size_dst);
                                  pdst += w_size_dst;
                                  yd ++;
                                  if (yd>=h_dst) return;
              }

              /* fait l'interpolation */
             for (count=0;count<ntc;count++) {
              attc[count]--;
	      if (attc[count] == 0 )
		{
                 attc[count]=ttc[count];
                 memcpy (pdst, pdst - w_size_dst, w_size_dst);
                 pdst += w_size_dst;
                 yd ++;
                 if (yd>=h_dst) return;
                }		
	      }
            }
       }
 else /* plus petit */
       {
          sh_src=0;
	  count = h_src >> 1;
	  for (ys=0; ys < h_src; ys++)
	    {
              psrc = src[ys];
	      count += h_dst;
	      if (count >= h_src)
		{ 		
		  putlineYUY2toRGB15(pdst, w_dst, psrc + xoffset, w_src);
		  count -= h_src;
		  pdst += w_size_dst;
		}
	
	    }
	}

}

