/******************************************************************************
 *                                                                            *
 * kizkool32snabrab.c                                                         *
 *                                                                            *
 * This code has been developped by KizKoool, Snabrab, Quenotte and others    *
 * for K!TV and adapted by Keuleu for xawdecode                               *
 *                                                                            *
 *                                                                            *
 * This program is free software; you can redistribute it and/or              *
 * modify it under the terms of the GNU General Public License                *
 * as published by the Free Software Foundation; either version 2             *
 * of the License, or (at your option) any later version.                     *
 *                                                                            *
 *                                                                            *
 * This program is distributed in the hope that it will be useful,            *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of             *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *
 * GNU General Public License for more details.                               *
 *                                                                            *
 *                                                                            *
 * You should have received a copy of the GNU General Public License          *
 * along with this program; if not, write to the Free Software                *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. *
 * Or, point your browser to http://www.gnu.org/copyleft/gpl.html             *
 *                                                                            *
 *                                                                            *
 *****************************************************************************/
#include <stdio.h>
#include "taztv.h"
#include "readconfig.h"

#define KIZKOOOL_32SNABRAB

#include "kizkool.h"

/* --------------- Selects compilation options  --------------- */

#define USE_ASM_SecamFiltering32snabrab 1
//#undef USE_ASM_SecamFiltering32snabrab

//#define USE_ASM_TestCorrectionUV 1
#undef USE_ASM_TestCorrectionUV

#define NEW_FINDFRAME 1
#undef  OLD_FINDFRAME

/* ------------------------------------------------------------ */


#define DWORD long
#define BOOL  int

// KizKoool extensions
#define ZEILENZAHL           287

static int nPixThreshold;
static int iLine;
static BOOL bFilterBlueLines = TRUE;

KIZKOOL_PARAM kizkool_param[NB_KIZKOOL_FILTER];
SNABRAB_PARAM snabrab_param;

int TypeImage;
unsigned int CurrentFrame;
int CurrentX;
int MovieScale;

static unsigned long long nMaskeU=0x0000FF000000FF00; //snabrab
static unsigned long long nMaskeV=0xFF000000FF000000; //snabrab
static unsigned long long nMaskeUV = 0xFF00FF00FF00FF00;

void setfilterparam(int param, int value)
{

 if (value <0) value = 0;
 if (value>100) value = 100;

 switch (param)
 {
  case KIZKOOL_UTHRESHOLD:
      value = rint(((double)value * 0.01) * 255.0);
      kizkool_param[BLUEFILTER_K32SNABRAB - 1].nUThreshold = value;
  break;

  case KIZKOOL_VTHRESHOLD:
      value = rint(((double)value * 0.01) * 255.0);
      kizkool_param[BLUEFILTER_K32SNABRAB - 1].nVThreshold = value;
  break;

  case KIZKOOL_YUVTHRESHOLD:
      value = rint(((double)value * 0.01) * 255.0);
      kizkool_param[BLUEFILTER_K32SNABRAB - 1].nYUVThreshold = value;
  break;

  case KIZKOOL_PIXFILTERTHRESHOLD:
      kizkool_param[BLUEFILTER_K32SNABRAB - 1].iPixFilterThreshold = value;
  break;
 }
}

void getfilterparam(int param, int *value)
{

 switch (param)
 {
  case KIZKOOL_UTHRESHOLD:
     *value = rint(( 100.0 * kizkool_param[BLUEFILTER_K32SNABRAB - 1].nUThreshold / 255.0));
  break;

  case KIZKOOL_VTHRESHOLD:
      *value = rint(( 100.0 * kizkool_param[BLUEFILTER_K32SNABRAB - 1].nVThreshold / 255.0));
  break;

  case KIZKOOL_YUVTHRESHOLD:
      *value = rint(( 100.0 * kizkool_param[BLUEFILTER_K32SNABRAB - 1].nYUVThreshold / 255.0));
  break;

  case KIZKOOL_PIXFILTERTHRESHOLD:
     *value = kizkool_param[BLUEFILTER_K32SNABRAB - 1].iPixFilterThreshold;
  break;
 }
}

void
init_kizkool32snabrab_filter (void)
{
  if (debug)
    fprintf(stderr, "kizkool32snabrab: init filter\n");

  setfilterparam( KIZKOOL_UTHRESHOLD,U_FILTER_THRESHOLD_K32SNABRAB );
  setfilterparam( KIZKOOL_VTHRESHOLD,V_FILTER_THRESHOLD_K32SNABRAB );
  setfilterparam( KIZKOOL_YUVTHRESHOLD,YUV_FILTER_THRESHOLD_K32SNABRAB );
  setfilterparam( KIZKOOL_PIXFILTERTHRESHOLD,PIX_FILTER_THRESHOLD_K32SNABRAB );

  /* No tune for snabrab */
  snabrab_param.FirstLine = FIRSTLINE_SNABRAB;
  snabrab_param.LastLine  = LASTLINE_SNABRAB;
  snabrab_param.Threshold = THRESHOLD_SNABRAB;

}

void end_kizkool32snabrab_filter (void)

{
 char tmp[16];
 int val;
 open_config_file();

 getfilterparam( KIZKOOL_UTHRESHOLD,&val );
 sprintf(tmp,"%d",val);
 save_config_value("u_filter_threshold",tmp,AT_END);

 getfilterparam( KIZKOOL_VTHRESHOLD,&val);
 sprintf(tmp,"%d",val);
 save_config_value("v_filter_threshold",tmp,AT_END);

 getfilterparam( KIZKOOL_YUVTHRESHOLD,&val );
 sprintf(tmp,"%d",val);
 save_config_value("yuv_filter_threshold",tmp,AT_END);

 getfilterparam( KIZKOOL_PIXFILTERTHRESHOLD,&val);
 sprintf(tmp,"%d",val);
 save_config_value("pix_filter_threshold",tmp,AT_END);

 close_config_file();
}

/*
  extern int nUThreshold, nVThreshold, iLine, nYUVThreshold, nPixThreshold;

  int NbFramesManquantes();
  int TestCorrectionUV(DWORD *pQuelle, DWORD *pSauve, DWORD *pColorQuelle,
  DWORD MasqueUV);

  int LineSaturation(DWORD *pQuelle, int CountX, int iLine_bugne, int
  iLine_sort, int Zone2_bugne);
  const __int64 nMaskeU=0x0000FF000000FF00; //snabrab
  const __int64 nMaskeV=0xFF000000FF000000; //snabrab
*/

// -------------------------------------------------------------
// snabrab 27/05/2001
// a) progrs important du filtrage bleu sur la zone infrieure :
// caractrisation de leur apparition SANS recourir au test de saturation
// des couleurs >> plus d'erreur de dtection sur la partie bugne bleu/violette infrieure
// mme sur des images fortement colores.

// b) progrs secondaire sur le rephasage anti-bavure automatique li  a):
// on n'effectue le test de rephasage qu'en cas d'apparition
// des lignes bleues en a)

// -------------------------------------------------------------
// snabrab Modififications du Filtres KizKoool SECAM v3.2
// a)filtrage violette avant et aprs destroumpfage sur seulement
// 1/4 des lignes

// b) Sur 2 zones, filtrage par bloc avec un seuil de lignes bugnes
// pour diminuer fausse dtection

// c)rephasage antibavure amliore par meilleure localisation des lignes bugnes testes

// ------------------------------------------------------------
// Filtres KizKoool SECAM v3.2
//
// Filtre lignes violettes + filtre anti-bavures
//
// Premires fonctions de traitement SECAM par Fantasio
// Ancien filtre bleu ASM par 1konnu
//
// Nouvel algorithme de dtection des lignes satures + bugfixes +
// traduction en C du filtre bleu et optimisations par KizKoool
//
// Ide et code original du filtre anti-bavures par 1Konnu
//
// Adaptation  K!TV + optimisations +
// rephasage dynamique du filtre anti-bavures par KizKoool
//
// Ide de l'exploitation de la variable CurrentFrame par E-nek
// Symbiose optimale des 2 filtres par Quenotte et KizKoool
//--------------------------------------------------------------



void
SecamFiltering32snabrab(DWORD **pLinesAddress, unsigned short *pSortLines)
{
  // Taille maximale d'une frame 768*287
  static BYTE ColorBackup[768 * ZEILENZAHL];
  BYTE *pColorQuelle, *pColorBuffer, *pQuelle, *pSource, *pix_courant;

  //snabrab
  int pSortLines_inverse[ZEILENZAHL],saturee2;
  BOOL Zone2_bugne=0;//snabrab

  //snabrab : inverse de pSortLines
  for (iLine=0; iLine <ZEILENZAHL; iLine++)
	{
      pSortLines_inverse[pSortLines[iLine]]=iLine;
	}

  nPixThreshold= (int) ((CurrentX*kizkool_param[BLUEFILTER_K32SNABRAB - 1].iPixFilterThreshold)/200);

  //bFilterBlueLines = kizkool_param[BLUEFILTER_K32SNABRAB - 1].smudge;

  if (bFilterBlueLines)
	{
      //snabrab : 2 me zone, dtection bloc bugn AVANT dstroumpf
      saturee2=0;
      Zone2_bugne=0;
      for (iLine=snabrab_param.FirstLine; iLine <snabrab_param.LastLine; iLine++)
		{
          if (LineSaturation((DWORD *)pLinesAddress[iLine], CurrentX>>1,0,0,0))
			//utilise la test de saturation "standard" par KIZKOOL
			{
              saturee2++;
			}
		}

      if (saturee2 > snabrab_param.Threshold) // Bloc sature
		{
          Zone2_bugne=1;
		}
	} // fin if bFilterBlueLines

  // fameuse boucle KIZKOOL et QUENOTTE  OPTIMALE pour bavure+bleu
  for (iLine=1+MovieScale; iLine < ZEILENZAHL-MovieScale; iLine++)
	{
      // pQuelle: pointeur sur la ligne source dans l'image dcode:
      pQuelle = (BYTE*) pLinesAddress[pSortLines[iLine]];
      // pColorBuffer: pointeur sur les couleurs non satures du buffer
      pColorBuffer = (BYTE*) (ColorBackup + CurrentX * iLine);

      //snabrab : test de saturation de la ligne, fonction modifie
      if (bFilterBlueLines && (LineSaturation(pLinesAddress[pSortLines[iLine]], CurrentX>>1,pSortLines[iLine],iLine,Zone2_bugne)))
		{
          // Ligne sature
          // Restauration de la saturation  partir du buffer de lignes non satures
          for (pix_courant=pQuelle+1; pix_courant<pQuelle+(CurrentX<<1); pix_courant=pix_courant+4)
			{
              *pix_courant=*pColorBuffer;
              *(pix_courant+2)=*(pColorBuffer+1);
              pColorBuffer=pColorBuffer+2;
			}
		}
      else
		{
          // Ligne non sature ou pas de filtre bleu
          // 1) Application du filtre anti-bavures

          if(iLine!=1+MovieScale)
			{
              // pColorQuelle: pointeur sur la ligne precedente dans l'image dcode:
              pColorQuelle=(BYTE*)pLinesAddress[pSortLines[iLine-1]];

              if ((((iLine%2)==0) && TypeImage) || (((iLine%2)!=0) && !TypeImage))
				{
                  // ligne paire de l'image de type 1 ou ligne impaire de l'image de type 2
                  pSource=pQuelle+3;
                  for (pix_courant=pColorQuelle+3; pix_courant<pColorQuelle+(CurrentX<<1); pix_courant=pix_courant+4)
					{
                      *pSource=*pix_courant;
                      pSource=pSource+4;
					}
				}
              else
				{
                  // ligne impaire de l'image de type 1 ou ligne paire de l'image de type 2
                  pSource=pQuelle+1;
                  for (pix_courant=pColorQuelle+1; pix_courant<pColorQuelle+(CurrentX<<1); pix_courant=pix_courant+4)
					{
                      *pSource=*pix_courant;
                      pSource=pSource+4;
					}
				}
			}

          // 2) Stockage de la ligne dans le buffer de lignes non satures
          if (bFilterBlueLines)
            {

#ifndef USE_ASM_SecamFiltering32snabrab
              for (pix_courant=pQuelle+1; pix_courant<pQuelle+(CurrentX<<1); pix_courant=pix_courant+4)
                {
                  *pColorBuffer= *pix_courant;
                  *(pColorBuffer+1)= *(pix_courant+2);
                  pColorBuffer=pColorBuffer+2;
                }
#else              
              // snabrab : traduction en ASM MMX plus rapide que c++
              // (-1% cpu en moins sur celeron 450 mhz)

              /*
              __asm__ __volatile__ (
                       "movl %0, %%edi              \n\t" //zone stockage: pColorBuffer
                       "movl %1, %%esi              \n\t" //encours: pQuelle
                       "movq nMaskeUV, %%mm7        \n\t"
                       "movl %2, %%eax              \n\t" // CurrentX
                       "xorl %%edx, %%edx           \n\t"
                       "movl $4, %%ecx              \n\t"
                       "divl %%ecx                  \n\t" // on divise le nbre de poins par 4, EAX quotient EDX reste
                       // si edx>0 : on traite les edx points (non multiple de 4)
                       "cmpl $0, %%edx              \n\t"
                       "je PixSui3                  \n\t"
                       "movq (%%esi), %%mm0         \n\t" //mm0 = V2 Y3 U2 Y2 V0 Y1 U0 Y0
                       "pand %%mm7, %%mm0           \n\t" //maskeUV V2 00 U2 00 V0 00 U0 00
                       "psrlw $8, %%mm0             \n\t" //0 V2 0 U2 0 V1 0 U1
                       "packuswb %%mm0, %%mm0       \n\t" //V2U2V1U1V2U2V1U1
                       "movd %%mm0, (%%edi)         \n\t"
                       "addl %%edx, %%esi           \n\t"
                       "addl %%edx, %%esi           \n\t"
                       "addl %%edx, %%edi           \n\t"
                       // fin traitement des edx points
                     
                       ".align 16\n\t"
                       "PixSui3:  \n\t" // boucle pour stocker les points restants (multiples de 4)
                       "movq (%%esi), %%mm0         \n\t" //mm0 = V2 Y3 U2 Y2 V0 Y1 U0 Y0
                       "pand %%mm7, %%mm0           \n\t" //maskeUV V2 00 U2 00 V0 00 U0 00
                       "addl $8, %%esi              \n\t"
                       "psrlw $8, %%mm0             \n\t" //0 V2 0 U2 0 V1 0 U1
                       "packuswb %%mm0, %%mm0       \n\t" //V2U2V1U1V2U2V1U1
                       "movd %%mm0, (%%edi)         \n\t"
                       "addl $4, %%edi              \n\t"
                       "decl %%eax                  \n\t"
                       "jg PixSui3                  \n\t"
                       "emms                        \n\t"
                       
                       : // output regs/vars
                       : // input regs
                       "m" (pColorBuffer), // %0
                       "m" (pQuelle),      // %1
                       "m" (CurrentX)      // %2           

                       : // clober list
                       "%eax", "%ecx", "%edx", "%edi", "%esi"
              );
              */
              __asm__ __volatile__ (
                       "movl %0, %%edi              \n\t" //zone stockage: pColorBuffer
                       "movl %2, %%eax              \n\t" // CurrentX

                       "movl %1, %%esi              \n\t" //encours: pQuelle
                       "movl %%eax, %%edx           \n\t"

                       //"xorl %%edx, %%edx           \n\t"
                       //"movl $4, %%ecx              \n\t"
                       //"divl %%ecx                  \n\t" // on divise le nbre de poins par 4, EAX quotient EDX reste
                       //// si edx>0 : on traite les edx points (non multiple de 4)
                       //"cmpl $0, %%edx              \n\t"

                       "shrl $2, %%eax              \n\t"
                       "andl $3, %%edx              \n\t"

                       "je PixSui3                  \n\t"
                       "movq (%%esi), %%mm0         \n\t" //mm0 = V2 Y3 U2 Y2 V0 Y1 U0 Y0

                       //"pand %%mm7, %%mm0           \n\t" //maskeUV V2 00 U2 00 V0 00 U0 00
                       "addl %%edx, %%esi           \n\t"
                       "psrlw $8, %%mm0             \n\t" //0 V2 0 U2 0 V1 0 U1

                       "addl %%edx, %%esi           \n\t"
                       "packuswb %%mm0, %%mm0       \n\t" //V2U2V1U1V2U2V1U1

                       "movd %%mm0, (%%edi)         \n\t"

                       "addl %%edx, %%edi           \n\t"
                       // fin traitement des edx points
                     
                       ".align 16\n\t"
                       "PixSui3:  \n\t" // boucle pour stocker les points restants (multiples de 4)
                       "movq (%%esi), %%mm0         \n\t" //mm0 = V2 Y3 U2 Y2 V0 Y1 U0 Y0
                       //"pand %%mm7, %%mm0           \n\t" //maskeUV V2 00 U2 00 V0 00 U0 00

                       "addl $4, %%edi              \n\t"
                       "psrlw $8, %%mm0             \n\t" //0 V2 0 U2 0 V1 0 U1

                       "addl $8, %%esi              \n\t"
                       "packuswb %%mm0, %%mm0       \n\t" //V2U2V1U1V2U2V1U1

                       "decl %%eax                  \n\t"

                       "movd %%mm0, -4(%%edi)       \n\t"
                       "jg PixSui3                  \n\t"
                       "emms                        \n\t"
                       
                       : // output regs/vars
                       : // input regs
                       "m" (pColorBuffer), // %0
                       "m" (pQuelle),      // %1
                       "m" (CurrentX)      // %2           

                       : // clober list
                       "%eax", "%ecx", "%edx", "%edi", "%esi"
              );
#endif // USE_ASM_SecamFiltering32snabrab

            } // fin if (bFilterBlueLines)

		} // fin de else
	} // boucle for

} // fin void SecamFiltering





// snabrab : Fonction dtection lign sature, modifie pour filtrage par zone
// Zone 1 de ligne 0  21 image stroumpfe
// Zone 2 de ligne 32  51 image stroumpfe
// Zone 4 de ligne ZEILENZAHL-32  ZEILENZAHL-1 image dstroumpfe
// Paramtres:
// pQuelle: Pointeur vers la ligne  tester
// CountX: Nombre de pixels  tester
// iLine_bugne : position ligne dans image non dschtroumpfe
// iLine_sort : position ligne dans image dschtroumpfe
// Zone2_bugne : flag indiquant si tout le bloc de lignes Zone 2 est schtroumpf

static int
LineSaturation(DWORD *pQuelle, int CountX, int iLine_bugne, int iLine_sort, int Zone2_bugne)
{
  DWORD *pix_courant;
  long U, V, Y, Seuil_NbPix;

  int nb_ligne_noire = MovieScale;

  if ((iLine_bugne<22) || (nb_ligne_noire>170)) //snabrab : 1 ere zone, dtection bugne AVANT dstroumpf
    //si nb_ligne_noire>170 on rebascule en test saturation KizKoool sur la totalit de l'image pour viter 
    //rapparition lignes bleues lies au mauvais desctroumpfage  cause des nombreuses lignes noires faussant le test corrlation nagra 
    {
      // Test de saturation de ligne par KizKoool
      Seuil_NbPix=nPixThreshold;
      pix_courant=pQuelle;
      while ((pix_courant<pQuelle+CountX) && (Seuil_NbPix>0))
        {
          U = *pix_courant>>8 & 0xff;
          V = *pix_courant>>24 & 0xff;
          Y = ((*pix_courant>>16 & 0xff)+(*pix_courant & 0xff))>>2;

          if ( !((((U>>1)+V)>Y+kizkool_param[BLUEFILTER_K32SNABRAB - 1].nYUVThreshold) && ((U>kizkool_param[BLUEFILTER_K32SNABRAB - 1].nUThreshold) || (V>kizkool_param[BLUEFILTER_K32SNABRAB - 1].nVThreshold))) )
			{
              Seuil_NbPix-=1;
			}
          pix_courant++;
        }
      return (Seuil_NbPix>0);
    }
  else
	{
      if ((iLine_bugne>31) && (iLine_bugne<52))
		{
          return (Zone2_bugne);
		}
      else
		{
          if (iLine_sort>=ZEILENZAHL-32)
            {
              return ((iLine_sort%2!=iLine_bugne%2));
            }
          else
            {
              return (1<0);
            }
		}
	}

}

#ifdef OLD_FINDFRAME
//
// Rephasage dynamique du filtre anti-bavures par KizKoool
// Algorithme bas sur les proprits des lignes satures
//
void
FindFrameType32snabrab(DWORD **pLinesAddress, unsigned short *pSortLines)
{
  DWORD *pQuelle, *pColorQuelle,*pLineBackup;
  static DWORD LineColorBackup[768];
  unsigned long MasqueToutSaufU, MasqueToutSaufV;
  int nb_saturees1, nb_saturees2;
  int pSortLines_inverse[ZEILENZAHL]; //snabrab
  nb_saturees1=0;
  nb_saturees2=0;

  MasqueToutSaufU = 0xFFFF00FF;	// Garde tout sauf la composante U
  MasqueToutSaufV = 0x00FFFFFF;	// Garde tout sauf la composante V


  // Dtection des frames loupes
  if (NbFramesManquantes()%2 == 1)
    TypeImage=!(TypeImage);

  if ((pSortLines[ZEILENZAHL-1])%2!=(ZEILENZAHL-1)%2)
	// snabrab : Dtection simple et trs sure des lignes bugnes infrieures
	// on ne cale la phase que quand il y a des lignes bugnes
	// plus rapide et moins d'erreur

	{
      pLineBackup = (DWORD*) LineColorBackup;
      nPixThreshold = (int) ((CurrentX*kizkool_param[BLUEFILTER_K32SNABRAB - 1].iPixFilterThreshold)/200);

      //snabrab : inverse de pSortLines
      for (iLine=0; iLine <ZEILENZAHL; iLine++)
        {
          pSortLines_inverse[pSortLines[iLine]]=iLine;
        }

      //modif snabrab : slection plus prcises des lignes bugnes  tester
      for (iLine=ZEILENZAHL-15; iLine < ZEILENZAHL; iLine++)
        {
          if (((pSortLines[iLine]+1)<ZEILENZAHL)&&(pSortLines_inverse[pSortLines[iLine]+1]<ZEILENZAHL-32)) 
            // snabrab
            {
              pQuelle = (DWORD*) pLinesAddress[pSortLines[iLine]+1]; //modifi snabrab
              pColorQuelle = (DWORD*)
                pLinesAddress[pSortLines[pSortLines_inverse[pSortLines[iLine]+1]-1]];

              if (((((pSortLines_inverse[pSortLines[iLine]+1])%2)==0) && TypeImage) || ((((pSortLines_inverse[pSortLines[iLine]+1])%2)!=0) && !TypeImage)) 
                //modifi snabrab
                {
                  // ligne paire de l'image de type 1
                  // ou ligne impaire de l'image de type 2
                  nb_saturees1+=TestCorrectionUV(pQuelle, pLineBackup, pColorQuelle, MasqueToutSaufV);
                  nb_saturees2+=TestCorrectionUV(pQuelle, pLineBackup, pColorQuelle, MasqueToutSaufU);
                }
              else
                {
                  // ligne impaire de l'image de type 1
                  // ou ligne paire de l'image de type 2
                  nb_saturees1+=TestCorrectionUV(pQuelle, pLineBackup, pColorQuelle, MasqueToutSaufU);
                  nb_saturees2+=TestCorrectionUV(pQuelle, pLineBackup, pColorQuelle, MasqueToutSaufV);
                }
            }
        }

      // Test de rephasage

      if ((nb_saturees1>nb_saturees2+4) && (min(nb_saturees1,nb_saturees2)<4))
		TypeImage=!(TypeImage);
	}
}
#endif

#ifdef NEW_FINDFRAME

#define LIGNES_TEST_PHASE 287


// E-nek 19/10/2001
// Detection du type de frame bas sur la proprit du signal SECAM:
// Le signal envoy contient Y et soit U ou V. le Tuner se charge ensuite
// de reconstituer le pixel YUV en prenant le U ou V de la ligne prcdente.

// Ligne 	Transmis 	Reconstitu par Tuner
// 1		Y1_U1		Y1_U1_VX
// 2		Y2_V2		Y2_U1_V2 (U1 = U ligne1)
// 3		Y3_U3		Y3_U3_V2 (V2 = V ligne2)
// 4		Y4_V4		Y4_U3_V4 ...
// 5		Y5_U5		Y5_U5_V4 ...
//
// Il existe donc deux types de trames, ce qui correspond  notre TypeImage .
// On essaie ici de dterminer si la trame est de type UV-UV-UV ou VU-VU-VU

// Remarque :
// Un grand merci  Fasouil pour avoir partag sa "trouvaille".
// TODO:
// Ce code devrait etre rendu plus robuste ...
void
FindFrameType32snabrab(DWORD **pLinesAddressEven, unsigned short *pSortLines)
{
  int py;
  short * pLine;
  BYTE donnee[LIGNES_TEST_PHASE];
  int  NbTest1;
  int  NbTest2;

  // donnee contient toutes les valeurs V du 1e pixel de chaque ligne
  //for (py=0;py <LIGNES_TEST_PHASE; py ++)
  for (py=52;py <LIGNES_TEST_PHASE; py ++) //vite les premieres lignes pouvant tre bugnes
                                           //car rsultat faux
	{
      pLine = (short *)pLinesAddressEven[py];
      donnee[py] = (BYTE) ((*pLine) >> 8);
	}

  NbTest1 = NbTest2 = 0;
  //for (py=0;py <LIGNES_TEST_PHASE; py += 2)
  for (py=52;py <LIGNES_TEST_PHASE-2; py += 2) 	//vite les premieres lignes pouvant tre bugnes
                                                //car rsultat faux
    {
      if (donnee[py] == donnee[py+1])
        NbTest1 ++;
      if (donnee[py+1] == donnee[py+2])
        NbTest2 ++;
	}

  // On fait un test sur un grand nombre d'chantillon pour tre certain.
  // En effet on peut avoir un U qui se repete sur plusieurs lignes ...
  if (NbTest1 < NbTest2)
    TypeImage = FALSE;
  else
    TypeImage = TRUE;
}
#endif

//
// Dtection des frames manquantes par KizKoool
// Sur une ide d'exploiter la variable CurrentFrame d'E-nek
//
// Valeur de retour:
// Nombre de frames non acquises
//
/*
static int
NbFramesManquantes(void)
{
  static int PrecedentFrame=-1;
  int NbFramesLoupees;

  if (CurrentFrame>PrecedentFrame)
    NbFramesLoupees=CurrentFrame-PrecedentFrame-1;
  else
    NbFramesLoupees=CurrentFrame-PrecedentFrame+4;

  PrecedentFrame = CurrentFrame;

  return NbFramesLoupees;
}
*/

static int
NbFramesManquantes(void)
{
  static unsigned int PrecedentFrame=0;
  unsigned int NbFramesLoupees;

  NbFramesLoupees = (CurrentFrame - PrecedentFrame)/2 -1;
  PrecedentFrame = CurrentFrame;
  //printf("NbFramesLoupees  = %u\n", NbFramesLoupees);

  return (int)NbFramesLoupees;
}


//
// Test de correction des Couleurs UV par KizKoool
//
// Paramtres :
// pQuelle      : Source
// pSauve       : Destination
// pColorQuelle : Rfrence pour reconstituer la couleur
// MasqueUV     : Masque de correction
//
static int
TestCorrectionUV(DWORD *pQuelle, DWORD *pSauve, DWORD *pColorQuelle,
                 DWORD MasqueUV)
{
  unsigned long MasqueInverse;
  DWORD *pix_courant;

  MasqueInverse= ~MasqueUV;

#ifndef USE_ASM_TestCorrectionUV
  for (pix_courant=pSauve; pix_courant<pSauve+(CurrentX>>1); pix_courant++)
    {
      *pix_courant=((*pQuelle & MasqueUV) | (*pColorQuelle & MasqueInverse));
      pColorQuelle++; pQuelle++;
    }
#else
  // snabrab : traduction asm mmx plus rapide que C++
  __asm__ __volatile__ (
  // plus rapide en mmx que c
  "movl %0, %%edi              \n\t" // ligne en cours: pQuelle
  "movl %1, %%ebx              \n\t" // pSauve
  "movl %2, %%esi              \n\t" // ligne prcdente: pColorQuelle
  "movq %3, %%mm7              \n\t" // MasqueInverse: uniquement U ou V
  "pcmpeqd %%mm6, %%mm6        \n\t" // 0xFFFFFFFFFFFFFFFF
  "pxor %%mm7, %%mm6           \n\t" // complment nMaske U ou V

  "movl %4, %%eax              \n\t" // CurrentX
  "xorl %%edx, %%edx           \n\t"
  "movl $4, %%ecx              \n\t"
  "divl %%ecx                  \n\t" // on divise le nbre de poins par 4, EAX quotient EDX reste
  // si edx>0 : on traite les edx points (non multiple de 4)
  "cmpl $0, %%edx              \n\t"
  "je PixSui4                  \n\t"
  "movq (%%esi), %%mm0         \n\t" //mm0 = V2 Y3 U2 Y2 V0 Y1 U0 Y0
  "movq (%%edi), %%mm1         \n\t" //mm1 = V'2 Y'3 U'2 Y'2 V'0 Y'1 U'0 Y'0
  "pand %%mm7, %%mm0           \n\t" //exemple  maskeV V2 00 00 00 V0 00 00 00
  "pand %%mm6, %%mm1           \n\t" //mm1=00 Y'3 U'2 Y'2 00 Y'1 U'0 Y'0
  "por %%mm0, %%mm1            \n\t" //mm1=V2 Y'3 U'2 Y'2 V0 Y'1 U'0 Y'0
  "movq %%mm1, (%%ebx)         \n\t"
  "addl %%edx, %%edx           \n\t" // 2 * nombre de points  traiter = nombre d'octets
  "addl %%edx, %%esi           \n\t"
  "addl %%edx, %%edi           \n\t"
  "addl %%edx, %%ebx           \n\t"
  // fin traitement des edx points


  ".align 16                   \n\t"
  "PixSui4:                    \n\t"
  "movq (%%esi), %%mm0         \n\t"//mm0 = V2 Y3 U2 Y2 V0 Y1 U0 Y0
  "movq (%%edi), %%mm1         \n\t"//mm1 = V'2 Y'3 U'2 Y'2 V'0 Y'1 U'0 Y'0
  "pand %%mm7, %%mm0           \n\t"//exemple  maskeV V2 00 00 00 V0 00 00 00
  "pand %%mm6, %%mm1           \n\t"//mm1=00 Y'3 U'2 Y'2 00 Y'1 U'0 Y'0
  "addl $8, %%esi              \n\t"
  "por %%mm0, %%mm1            \n\t"//mm1=V2 Y'3 U'2 Y'2 V0 Y'1 U'0 Y'0
  "movq %%mm1, (%%ebx)         \n\t"
  "addl $8, %%edi              \n\t"
  "addl $8, %%ebx              \n\t"
  "decl %%eax                  \n\t"
  "jg PixSui4                  \n\t"//boucle non affine pour vitesse maxi
  "emms                        \n\t"

  : // output regs/vars

  : // input regs
  "m" (pQuelle),       // %0
  "m" (pSauve),        // %1
  "m" (pColorQuelle),  // %2
  "m" (MasqueInverse), // %3
  "m" (CurrentX)       // %4

  : // clober list
  "%eax", "%ebx", "%ecx", "%edx", "%edi", "%esi"
  ); // fin asm
#endif // USE_ASM_TestCorrectionUV

  return LineSaturation(pSauve, CurrentX>>1,0,0,0);
}

