/* Thanks keuleu */
extern short colortable[1380 * 4];

static unsigned long nMaskY[2] = { 0x00ff00ff, 0x00ff00ff };
static unsigned long nMaskUV[2] = { 0xff00ff00, 0xff00ff00 };
static unsigned long nPlus128[2] = { 0x80008000, 0x80008000 };

static volatile unsigned long ands[2] = { 0x00f800f8, 0x00f800f8 };
static char pCromaPuffer[2*768];

inline void
palputlineYVU (int i1, int i2, int offset32, int y, int perm_y, int xsize, void *p2,
         void *p1)
{
  __asm__ __volatile__ (
                        // if (MSB(perm_y) == 1) i.e. if (perm_y > 32767 or 16383??) goto putline.m2
                        "movl %4, %%eax\n\t"    // perm_y
                        "testl %%eax, %%eax\n\t"
                        "js  putlineYVU.m2\n\t"

                        // if (perm_y >= 32) goto putlineYVU.m1
                        "cmpl $0x00000020, %%eax\n\t"
                        "jae putlineYVU.m1\n\t"

                        // else perm_y = perm_y - offset32;
                        "subl %2, %%eax\n\t"    // offset32
                        
     "putlineYVU.m1:\n\t"

                        // edi = 4 * (perm_y - y) + 1248
                        "subl %3, %%eax\n\t"    // y
                        "leal 0x4E0(, %%eax,4), %%edi\n\t"

                        // i1 = i1 & 0x01
                        // i2 = i2 & 0x01
                        "movl %0, %%eax\n\t"    // i1
                        "movl %1, %%ebx\n\t"    // i2
                        "andl $00000001, %%eax\n\t"
                        "andl $00000001, %%ebx\n\t"

                        // edi = edi + (i2 + 2 * i1)
                        "leal (%%ebx, %%eax,2), %%eax\n\t"
                        "addl %%eax, %%edi\n\t"

                        // edi = colortable + 8 * edi
                        // i.e. pColorFaktor = colortable + 8 * ( 4 * (perm_y - y) + 1248 + i2 + 2 * i1 )
                        "leal colortable(, %%edi,8), %%edi\n\t"

     "putlineYVU.m2:\n\t"

                        "movl %7, %%edx\n\t"          // p1
                        "movl %5, %%ecx\n\t"          // xsize

                        "movq (%%edi),  %%mm7\n\t"    // mm7 = *pColorFaktor (64 bits)
                        "movl %8, %%edi\n\t" // pCromaPuffer
                        "movq nMaskY,   %%mm4\n\t"
                        "movq nMaskUV,  %%mm5\n\t"
                        "movq nPlus128, %%mm6\n\t"

                        "shrl $3, %%ecx\n\t"          // xsize (nBreiteQuelle) /= 8
                        "movl %6, %%ebx\n\t"          // p2 (pZiel)

                        "movq (%%edx), %%mm0\n\t"     // mm0 = *p1 (pSource)

                        ".align 16\n\t"

     "putlineYVU.NextPixel:\n\t"
                        "movq (%%edx), %%mm0\n\t"     // mm0 = *p1
                        "addl $8, %%edx\n\t"          // p1 += 8
                        "movq %%mm0, %%mm2\n\t"       // mm2 = V2 Y3 U2 Y2 V0 Y1 U0 Y0  Y nach mm2
                        "psubb %%mm6, %%mm0\n\t"      // mm0 = V2 Y3 U2 Y2 V0 Y1 U0 Y0  U-128 V-128
                        "pand %%mm4, %%mm2\n\t"       // mm2 = 00 Y3 00 Y2 00 Y1 00 Y0  Y Ausmaskieren
                        "psraw $8, %%mm0\n\t"         // mm0 = V2 V2 U2 U2 V0 V0 U0 U0  U und V auf 16 Bit erweitern
                        "movq %%mm0, %%mm1\n\t"       // mm1 = V2 V2 U2 U2 V0 V0 U0 U0  Zweites Pixelpaar nach mm1
                        "punpckldq %%mm0, %%mm0\n\t"  // mm0 = V0 V0 U0 U0 V0 V0 U0 U0  Untere 32 Bit in die oberen 32 Bit kopieren
                        "punpckhdq %%mm1, %%mm1\n\t"  // mm1 = V2 V2 U2 U2 V2 V2 U2 U2  Obere 32 Bit in die unteren 32 Bit kopieren
                        "pmaddwd %%mm7, %%mm0\n\t"    // mm0 = v0 v0 v0 v0 u0 u0 u0 u0  u0 = U0 * *(pColorFaktor+0) + V0 * *(pColorFaktor+1);
                                                      //   v0 = U0 * *(pColorFaktor+2) + V0 * *(pColorFaktor+3);
                        "pmaddwd %%mm7, %%mm1\n\t"    // mm1 = v2 v2 v2 v2 u2 u2 u2 u2  u2 = U2 * *(pColorFaktor+0) + V2 * *(pColorFaktor+1);
                                                      //   v2 = U2 * *(pColorFaktor+2) + V2 * *(pColorFaktor+3);
                        "psrad $14, %%mm0\n\t"        // mm0 = v0 v0 v0 v0 u0 u0 u0 u0  Geteilt durch 16384
                        "psrad $14, %%mm1\n\t"        // mm1 = v2 v2 v2 v2 u2 u2 u2 u2  Geteilt durch 16384
                        "packssdw %%mm1, %%mm0\n\t"   // mm0 = v2 v2 u2 u2 v0 v0 u0 u0  Ergebnis auf 16 bit krzen
                        "movq -8(%%edi, %%ecx, 8), %%mm3\n\t"  // mm3 = v2 v2 u2 u2 v0 v0 u0 u0  Farbwerte der letzten Zeile
                        "movq %%mm0, -8(%%edi, %%ecx, 8)\n\t"  // mm0 = v2 v2 u2 u2 v0 v0 u0 u0  Farbe fr nchste Zeile merken
                        "paddsw %%mm3, %%mm0\n\t"     // mm0 = v2 v2 u2 u2 v0 v0 u0 u0  Farbwerte der letzten Zeile addieren
                        "packsswb %%mm0, %%mm0\n\t"   // mm0 = v2 u2 v0 u0 v2 u2 v0 u0  Auf 8 Bit krzen
                        "punpcklbw %%mm0, %%mm0\n\t"  // mm0 = v2 v2 u2 u2 v0 v0 u0 u0
                        "pand %%mm5, %%mm0\n\t"       // mm0 = v2 00 u2 00 v0 00 u0 00  U und V ausmaskieren
                        "psubb %%mm6, %%mm0\n\t"      // mm0 = v2 00 u2 00 v0 00 u0 00  U+128 V+128
                        "por %%mm0, %%mm2\n\t"        // mm2 = v2 Y3 u2 Y2 v0 Y1 u0 Y0

                        "movq %%mm2, (%%ebx)\n\t"      // *pZiel = mm2
                        "addl $8, %%ebx\n\t"          // pZiel += 8

                        "decl %%ecx\n\t"              // nBreiteQuelle--
                        "jne putlineYVU.NextPixel\n\t" // Sind noch weitere Pixel in dieser Zeile

                        "emms\n\t"                     // MMX zurcksetzen

                        :    /* no output */
                        :        /* input */
                        "g" (i1),    /* %0 */
                        "g" (i2),    /* %1 */
                        "g" (offset32),    /* %2 */
                        "g" (y),    /* %3 */
                        "g" (perm_y),    /* %4 */
                        "g" (xsize),    /* %5 */
                        "g" (p2),    /* %6 */
                        "g" (p1),    /* %7 */
                        "g" (pCromaPuffer) /* %8 */
                        :        /* modified regs */
                        "eax", "ebx", "ecx", "edx", "edi"
                        /*, "mm0", "mm1", "mm2", "mm3", "mm4", "mm5", "mm6", "mm7" */
                        );                        
}


