/*************************************************************************
* Taztv.h                                                                *
* Maupatz, Keuleu 2001                                                   *
* taztv is free software; you can redistribute it and/or modify          *
* it under the terms of the GNU General Public License as published by   *
* the Free Software Foundation; either version 2 of the License, or      *
* (at your option) any later version.                                    *
*                                                                        *
* Taztv is distributed in the hope that it will be useful,               *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
* GNU General Public License for more details.                           *
*                                                                        *
* You should have received a copy of the GNU General Public License      *
* along with this program; if not, write to the Free Software            *
*                                                                        *
*************************************************************************/

#ifndef TAZTV_H
#define TAZTV_H

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <X11/Xlib.h>
#include <X11/keysym.h>
#include <X11/cursorfont.h>

#ifdef HAVE_MITSHM
/* Pour XShm */
#include <X11/Xutil.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <X11/extensions/XShm.h>
#endif

#ifdef HAVE_XV
/* Pour Xv */
#include <X11/extensions/Xv.h>
#include <X11/extensions/Xvlib.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <math.h>
#include <errno.h>
#include <fcntl.h>
#include <string.h>
#include <signal.h>
#include <pthread.h>

#include <linux/videodev.h>
#include <linux/soundcard.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <sys/stat.h>
#include <sys/mman.h>

#define YUY2 (('2'<<24)|('Y'<<16)|('U'<<8)|'Y')
#define PALETTE VIDEO_PALETTE_YUV422
#define W 768
#define H 576
#define PBUF 32
#define MAXBUFFERS 4
#define HT (H/2)
#define HTD (HT-1)
#define TLINEYUY2 (W*2)
#define T510YUY2 (((H-2)-2*PBUF)*TLINEYUY2)
#define TPMB (PBUF*922*2)

#define USE_XV   0
#define USE_XLIB 1

#define OFF  0
#define ON   1
#define AUTO 2

#define HIGHQ 0
#define LOWQ  1

extern int debug;
extern int disable_xshm;
extern int disable_xv;
extern int disable_vm;
extern char user_dir[255];
extern int have_sse;
extern int have_sse2;
extern int have_mmx;
extern int have_mmxext;
extern int have_3dnow;
extern int have_3dnowext;
extern int cpu_mm_support;

char *getenv();
extern volatile sig_atomic_t not_end_taztv;

#endif

