/*************************************************************************
* video.c                                                                *
* Maupatz,keuleu     2001                                                *
* taztv is free software; you can redistribute it and/or modify          *
* it under the terms of the GNU General Public License as published by   *
* the Free Software Foundation; either version 2 of the License, or      *
* (at your option) any later version.                                    *
*                                                                        *
* Taztv is distributed in the hope that it will be useful,               *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
* GNU General Public License for more details.                           *
*                                                                        *
* You should have received a copy of the GNU General Public License      *
* along with this program; if not, write to the Free Software            *
*                                                                        *
*************************************************************************/

#include  "taztv.h"
#include  "nagra.h"
#include  "yuyv2rgb.h"
#include  "x11.h"
#include  "video.h"
#include  "frequencies.h"
#include  "readconfig.h"
#include  "autodetect.h"
#include  "kizkool.h"
#include  "nagraudio.h"
#include  "i18n.h"
#include  "palputline.h"
#include  "../mm/pluginvideo.h"

/* filter support */
#define BTTV_FIELDNR            _IOR('v' , BASE_VIDIOCPRIVATE+2, unsigned int)

/* pal support */
#define BTTV_BURST_ON      	_IOR('v' , BASE_VIDIOCPRIVATE+4, int)
#define BTTV_BURST_OFF     	_IOR('v' , BASE_VIDIOCPRIVATE+5, int)
#define BURSTOFFSET 76


int nbchaines = 0;
static int cur_tv_channel=1;

struct TV_CHANNEL tv_channel_list[NB_TV_CHANNEL_MAX];

char video_channel_list[16][32];
static int current_video_channel;

int f=-1;

char video_device[255]="";

struct video_capability vdcap;
struct video_picture    vdp;
struct video_window     vdw;
struct video_channel    vdc;
struct video_tuner      vdt;
struct video_audio      vda;

/* screen grab */
int gb_grab=0;
int gb_sync=0;
struct video_mmap        *gb;
struct video_mbuf    vdmb = { 2*0x151000, 0, {0,0x151000 }};
char *map=NULL;

int pal;
int norm_changed=0;
int w_size;
int h_size;
static int pal_xoffset;
static int pal_w_size;

static int detect_tag=0;
static int detect_ratio=0;
static int old_img_height=0;

int NBWBUFF=0;

/* buffer rsultat */
char *pimg[H];

struct pmb_s
{
 char t[TPMB];
};

struct pmb_s *pmb;

/* buffers de translation */
struct trx_s
{
 char *t[HT];
};

struct trx_s *tri;
struct trx_s *trp;

char *mbp[HT];
char *mbi[HT];

short permp[HTD];
short permi[HTD];
int burst_phase_p;
int burst_phase_i;

int img=0;
int imgq=0;
int imgw=0;

int decodeur = OFF;
int auto_decodeur = OFF;
int synchro_sound_video = OFF;
int filter=OFF;
int decode_trame_impaire=0;
int sauve_decode_trame_impaire=0;
int flag_fast_quality = ON; /* demarre  384 x 288 */

//0 NATIVE
//1 MEUHMEUH
int plug_decoder=0;

//solve the gcc segfault compiler
static int pbUpdateBuffer,pbViewBuffer;
static int mat_ok;

QuenotteTV_VideoPlugin *meuhmeuh=NULL;
QuenotteTV_VideoPlugin *init_mm_Plugin(char *);

/* sound */
int decode_sound=0;
int mute_sound=OFF;

int get_video_decode_status()
{
 return decodeur;
}

int set_plug_decoder(int value)
{
 plug_decoder=value;
 return value;
}

/**************************************************************************/
int init_translation() {
    int i,j;
    char *src;
    if (h_size>=H) {
    /* decode mode */
          for (i=0;i<NBWBUFF;i++){
               src = map + vdmb.offsets[i];
   /* Translation adresse ligne principale on dcale de PBUF=32 lignes */
               for (j=0;j<(HTD-PBUF);j++){
                    trp[i].t[j+PBUF] = src + 4 * j * pal_w_size;
                    tri[i].t[j+PBUF] = src + (4 * j + 2) * pal_w_size;
               }
  /* Translation ligne impaire une c'est OK*/
               for (j=0;j<PBUF;j++) tri[i].t[j]= src+((h_size-2)-2*PBUF)*pal_w_size*2+j*pal_w_size*4;
          }

  /* Translation du reste des buffers ligne paire */
        for (i=1;i<NBWBUFF;i++) for (j=0;j<PBUF;j++) trp[i].t[j]=(char*)&pmb[i-1] + j * pal_w_size * 2;

  /* On boucle la boucle    */
        for (j=0;j<PBUF;j++) trp[0].t[j]=(char *)&pmb[NBWBUFF-1] + j * pal_w_size * 2;

    }

  /* Precaution */
     for (i=0;i<h_size;i++) pimg[i] = map + vdmb.offsets[1] + (i * pal_w_size * 2);

  /* Meumeuh */
   if (meuhmeuh)
   {
    meuhmeuh->NbBuff=NBWBUFF;
    for (i=0;i<NBWBUFF;i++){
                  src = map + vdmb.offsets[i];
      for (j=0;j<HT;j++)
      {
       meuhmeuh->EvenLines[i][j] =(short *) (src +  4 * j * pal_w_size);
       meuhmeuh->OddLines [i][j] =(short *) (src + (4 * j + 2) * pal_w_size);
       //Precaution
       // meuhmeuh->OutEvenLines[i][j] =(short *) (src +  4 * j * pal_w_size);
       // meuhmeuh->OutOddLines [i][j] =(short *) (src + (4 * j + 2) * pal_w_size);
       meuhmeuh->OutEvenLines[i][j] = 0;
       meuhmeuh->OutOddLines [i][j] = 0;
      }
   }
  }
    return 0;
}

int decode_frame(){
    char **srci,**srcp,*dst,*src;
    short  *pi,*pp;
    int i,p1;
    int j;


    srci= (char**)&tri[img];
    pi=&permi[0];

    if (decode_trame_impaire) {

          decode_nagra(pi,srci,pal_w_size);
          burst_phase_i=burst_phase;

           /* Filtre de KizKoool */
 	   if (filter)
 	     {
               MovieScale = ysbar/2-1;
               if (MovieScale < 0) MovieScale = 0;
 	       CurrentX = pal_w_size;
               TypeImage = !(TypeImage);
               FindFrameType32snabrab ((long **)srci, pi);
 	       SecamFiltering32snabrab((long **)srci, pi);
 	     }
 	   /* Fin du Filtre de KizKoool */

           /* transfert */
        for (i=0;i<HTD;i++){
	     j = (i << 1);
             pimg[j]=srci[pi[i]];
              /* double res */
	     j++;
             pimg[j]=srci[pi[i]];
        }
          /* Pas besoin de trame paire */

    }
    else {
           srcp=(char **)&trp[img];
           pp=&permp[0];

           /* permutations  pour le paradis */
           decode_nagra(pp,srcp,pal_w_size);
           burst_phase_p=burst_phase;
           decode_nagra(pi,srci,pal_w_size);
           burst_phase_i=burst_phase;

           /* Filtre de KizKoool */
	   if (filter)
	     {
	       CurrentX = pal_w_size;
	       /* Trame Paire */
               MovieScale = ysbar/2-1;
               if (MovieScale < 0) MovieScale = 0;
	       FindFrameType32snabrab((long **)srcp, pp);
	       SecamFiltering32snabrab((long **)srcp, pp);

	       /* Trame Impaire */
	       TypeImage=!(TypeImage);
	       SecamFiltering32snabrab((long **)srci, pi);
	     }
	   /* Fin du Filtre de KizKoool */

           /* transfert pour reconstitution */
          for (i=PBUF;i<HTD;i++){
	        j = (i<<1);
                pimg[j  ] = srcp[pp[i]];
                pimg[j+1] = srci[pi[i]];
           }

           /* double res si il est lent  */

	    if (fps<23) { srcp=srci; pp=pi; }

           for (i=0;i<PBUF;i++){
              j = (i<<1);
              pimg[j+1] = srci[pi[i]];
              pimg[j  ] = srcp[pp[i]];
           }

           /* Sauve en dernier lignes impaires */
           dst=(char*)&pmb[img];
           src = map + vdmb.offsets[img] +  (((h_size-2)-2*PBUF)*pal_w_size*2) + pal_w_size * 2;
           for (i=0;i<PBUF;i++){
                 p1 = i * pal_w_size * 2;
                 memcpy(dst + p1, src + (p1 * 2),pal_w_size * 2);
                }
            }
 return 0;
}

int decode_meuhmeuh_frame()
{
  int i,j;

  meuhmeuh->Full_Field=!decode_trame_impaire;
  meuhmeuh->CurrentFrame=img;
  meuhmeuh->CurrentX=pal_w_size;
  meuhmeuh->MovieBoost=ysbar/2-1;
  if (meuhmeuh->MovieBoost<0) meuhmeuh->MovieBoost = 0;
  
  // Mise  zro du tampon pour eviter le buffer overrun de meuhmeuh
  i = (img+1) % NBWBUFF;
  *(meuhmeuh->OutEvenLines[i])=0;
  *(meuhmeuh->OutOddLines [i])=0;

  // Paire
  meuhmeuh->DoStuff(0,&pbUpdateBuffer,&pbViewBuffer);
  mat_ok = pbUpdateBuffer;

  // impaire
  meuhmeuh->DoStuff(1,&pbUpdateBuffer,&pbViewBuffer);

  if (meuhmeuh->Full_Field) mat_ok = mat_ok && pbUpdateBuffer;
  else mat_ok = pbUpdateBuffer;

  if (!mat_ok) return 1;

  // Mise  jour des lignes vers mon standard
  for (i=0;i<HTD;i++){
	     j = (i << 1);
             pimg[j]=(char *) meuhmeuh->OutEvenLines[img][i];
             j++;
             if (meuhmeuh->Full_Field)
	         pimg[j]=(char *)  meuhmeuh->OutOddLines[img][i];
              else
                 pimg[j]=(char *) meuhmeuh->OutEvenLines[img][i];
        }
   return 0;
}

/*************************************************************************/
/* Prochaine version FIFO avec thread de capture */
int
grab_queue(struct video_mmap *gb)
{
  if (-1 == ioctl(f,VIDIOCMCAPTURE,gb)) {
    if (errno == EAGAIN)
      fprintf(stderr,"grabber chip can't sync (no station tuned in?)\n");
    else
      fprintf(stderr,"ioctl VIDIOCMCAPTURE(%d,%x,%dx%d): %s\n",
	      gb->frame,gb->format,gb->width,gb->height,
	      strerror(errno));
    return -1;
  }
  gb_grab++;
  return 0;
}

int
grab_wait(struct video_mmap *gb)
{
  if (-1 == ioctl(f,VIDIOCSYNC,&(gb->frame))) 
  {
    perror("ioctl VIDIOCSYNC");
    return -1;
  } else
    gb_sync++;
    return 0;
}

int
cap_img()
{
   unsigned int fieldnr;


   if (pal)
        {
           ioctl (f, BTTV_BURST_ON, NULL);
        }

  while ((gb_grab-gb_sync)<NBWBUFF)
  {
   if (-1 == grab_queue(&gb[imgq]))
   {
     /* free all reset */
     for (imgw=0;imgw<NBWBUFF;imgw++) grab_wait(&gb[imgw]);
     gb_grab=gb_sync=imgq=imgw=0;
     return -1;
   }
   imgq++;
   if (imgq>=NBWBUFF) imgq=0;
  }

  if (-1 == grab_wait(&gb[imgw]))
  {
   /* free all reset */
   for (imgw=0;imgw<NBWBUFF;imgw++) grab_wait(&gb[imgw]);
   gb_grab=gb_sync=imgq=imgw=0;
   return -1;
  }

  img=imgw;

  imgw++;
  if (imgw>=NBWBUFF) imgw=0;

  if (filter){
      if (-1 != ioctl (f, BTTV_FIELDNR, &fieldnr))
      {
        CurrentFrame = fieldnr;
       //  printf("%d \n",fieldnr);
      }
   }
  return 0;

}

/**********************************************************************************/

int get_img_rb(){
    int i=0;
    int i1, i2, offset32, y1;
    char *p1=0;
    char *p2=0;

 switch (cap_img()) {
               case -1:
                      if (debug)
                      fprintf(stderr," No Frame\n");
                      return -1;
               break;

   default:

       /* Auto decode */
     if (auto_decodeur) if (++detect_tag>25)
                           {
                             detect_tag=0;
                             if (synchro_sound_video && decodeur)
                                autodetect ((char **)&tri[img], &decodeur,w_size);
                             else
                                decodeur = decode;
                           }

     if (decodeur) {
                if (plug_decoder==0)
                    decode_frame();
                else
                    if (decode_meuhmeuh_frame()) return 1;
                   }

 /* bandes noires detection */

    if (image_ratio==3) /* automatic 5s */
    {
     if (++detect_ratio>125)
     {
       detect_ratio=0;

       if (h_size==H)
       {
         if (pal)
	 {
	   i1 = W + W*BURSTOFFSET/922;
           i1 &= ~1;
	 }
	 else
	 {
	  i1=W;
	 }
       } else i1=pal_w_size;

       if (!decodeur)
       for (i=0;i<h_size;i++) pimg[i] = map + vdmb.offsets[img] + (i * pal_w_size * 2);
       i2 = find_img_height(pimg,pal_w_size,h_size);

       // printf ("Set bar -> w %d : h %d : r %d\n",i1,h_size,i2);

       // change only if > 12% variation and <20/9
       if ((abs(old_img_height-i2)*8>h_size) && (9*i1<20*i2))
       {
        old_img_height = i2;
        set_img_format (i1,i2);
       }
     }
    } else old_img_height=h_size;

 /***************************************Pal*****************************************/

 if (pal) {

    if (!decodeur) {

      switch (in_use) {
          case USE_XV:
                      for (i=0+ysbar;i<(h_size - 2 - ysbar);i++)
                                memcpy(rb + i * w_size * 2,
                                       map + vdmb.offsets[img] + i * pal_w_size * 2 + pal_xoffset,
	                               w_size * 2);
          break;

          case USE_XLIB:
               for (i=0;i<h_size;i++) pimg[i] = map + vdmb.offsets[img] + (i * pal_w_size * 2);
               PutImage (rb + ydbar * wrw * pixel_size,
	                 wrw,
			 wrh - 2 * ydbar,
			 pimg + ysbar,
			 w_size,
		         h_size - 2 * ysbar, pal_xoffset);
         break;
     }
     return 0;
   }

  /* decode do the permutation */
  // nur verkleinern ist sinnvoll

   p2 = rb + ysbar * w_size * 2;

   /* half frame */

 if (decode_trame_impaire){

    for (i = ysbar; i < (h_size - 2 - ysbar); i+=2)
        {
          y1 = i / 2;

          p1 = tri[img].t[permi[y1]] + pal_xoffset;

          offset32 = 0x1a;
          i1 = y1 & 1;
          if (burst_phase_i == 0) i1 ^= 1;
          i2 = permi[y1] & 1;
          if (burst_phase_i == 0) i2 ^= 1;

          if (in_use==USE_XV)
                  {
                    palputlineYVU (i1, i2, offset32, y1, permi[y1],w_size * 2, p2, p1);
                    memcpy(p2 + w_size * 2, p2,w_size * 2);
                    p2 += 4 * w_size;
                  }
                  else
                  {
                     palputlineYVU (i1, i2, offset32, y1, permi[y1], w_size * 2,p1, p1);
                  }
        }

     if (in_use==USE_XLIB)
               PutImage (rb + ydbar * wrw * pixel_size,
	                 wrw,
			 wrh - 2 * ydbar,
			 pimg + ysbar,
			 w_size,
		         h_size - 2 * ysbar,pal_xoffset);


    return 0;
  }

     /*************************** Full frame **********************************/
     for (i = ysbar; i < (h_size - 2 - ysbar); i++)
       {
          y1 = i / 2;
          if (i & 1)
            {                    // Zeile im zweiten Halbbild

                  p1 = trp[img].t[permp[y1]] + pal_xoffset;

                  offset32 = 0x1a;
                  i1 = y1 & 1;
                  if (burst_phase_p == 0) i1 ^= 1;

                  i2 = permp[y1] & 1;
                  if (burst_phase_p == 0) i2 ^= 1;

                  if (in_use==USE_XV)
                  {
                  palputlineYVU (i1, i2, offset32, y1, permp[y1],w_size * 2, p2, p1);
                  }
                  else {
                         palputlineYVU (i1, i2, offset32, y1, permp[y1], w_size * 2,p1, p1);
                       }

            }
          else
            { /* pair */                   // Zeile im ersten Halbbild

              if (permi[y1] < 33)
                  {
                  // Zeile steht nicht zur Verfgung,
                  // also einfach entsprechende
                  // Zeile des zweiten Halbbildes ausgeben

                      p1 = trp[img].t[permp[y1]] + pal_xoffset;

                      offset32 = 0x1a;
                      i1 = y1 & 1;
                      if (burst_phase_p == 0) i1 ^= 1;

                      i2 = permp[y1] & 1;
                      if (burst_phase_p == 0) i2 ^= 1;

                      if (in_use==USE_XV)
                        {
                            palputlineYVU (i1, i2, offset32, y1, permp[y1],w_size * 2, p2, p1);
                        }
                      else {
                             palputlineYVU (i1, i2, offset32, y1, permp[y1], w_size * 2,p1, p1);
                           }

                   }
                  else
                   {
                      p1 = tri[img].t[permi[y1]] + pal_xoffset;

                      offset32 = 0x19;
                      i1 = y1 & 1;
                      if (burst_phase_i == 1) i1 ^= 1;

                      i2 = permi[y1] & 1;
                      if (burst_phase_i == 1) i2 ^= 1;

                      if (in_use==USE_XV)
                        {
                        palputlineYVU (i1, i2, offset32, y1, permi[y1],w_size * 2, p2, p1);
                        }
                      else {
                             palputlineYVU (i1, i2, offset32, y1, permi[y1], w_size * 2,p1, p1);
                           }


                   }
           }

         p2 +=w_size * 2;
       }

   if (in_use==USE_XLIB)
               PutImage (rb + ydbar * wrw * pixel_size,
	                 wrw,
			 wrh - 2 * ydbar,
			 pimg + ysbar,
			 w_size,
		         h_size - 2 * ysbar,pal_xoffset);

   return 0;
     }

   /**************************************** secam ******************************************/
     switch (in_use) {
          case USE_XV:
               if (decodeur) {
                                for (i=0+ysbar;i<(h_size - 2 - ysbar);i++)
                                memcpy(rb + i * w_size * 2, pimg[i], w_size * 2);
                             }
                   else
                       memcpy(rb + ysbar * w_size * 2,
                                  map + vdmb.offsets[img] + ysbar * w_size * 2,
	                          w_size * 2 * (h_size - 2*ysbar));
          break;

          case USE_XLIB:

               if (!decodeur){
                     for (i=0;i<h_size;i++)
                     pimg[i] = map + vdmb.offsets[img] + (i * w_size * 2);
                             }
               PutImage (rb + ydbar * wrw * pixel_size,
	                 wrw,
			 wrh - 2 * ydbar,
			 pimg + ysbar,
			 w_size,
		         h_size - 2 * ysbar,0);
         break;
     }

    }
return 0;

}


int init_video (){
 int i,rc;

/********* external ********/
 init_kizkool32snabrab_filter ();
 meuhmeuh=init_mm_Plugin(user_dir);

/******************************** Video *****************************************/

  if (video_device[0]==0) strcpy (video_device, "/dev/video0");

  f=open (video_device,O_RDWR);
  if (f<=0)
  {
    f=open ("/dev/video0",O_RDWR);
    if (f>0) strcpy (video_device, "/dev/video0");
  }
  if (f<=0)
  {
    f=open ("/dev/v4l/video0",O_RDWR);
    if (f>0) strcpy (video_device, "/dev/v4l/video0");
  }
  if (f<=0)
  {
    f=open ("/dev/video/video0",O_RDWR);
    if (f>0) strcpy (video_device, "/dev/video/video0");
  }
 if (f<0)  {
              fprintf (stderr,_("Can't open %s \n"),video_device);
              return -1;
            }
 if (debug) fprintf (stderr,"Open device : %s \n",video_device);

 /***************  Cap  **************************************/
 rc = ioctl(f,VIDIOCGCAP,&vdcap);
 if (rc!=0) { fprintf (stderr,"Can't VIDIOCGCAP \n"); return -1; }

 if (vdcap.channels==0) { fprintf (stderr,"No channels \n"); return -1; }
 if (!(vdcap.type & VID_TYPE_CAPTURE)) { fprintf (stderr,"Can't capture \n"); return -1; }

 /* Channels name */
 video_channel_list[0][0]=0;
 for (i=0;i<vdcap.channels;i++)
 {
   vdc.channel=i;
   rc = ioctl(f,VIDIOCGCHAN,&vdc);
   if (rc!=0) { fprintf(stderr,"Can't VIDIOCGCHAN %d \n",rc); return -1; }
   strcpy(video_channel_list[i],vdc.name);
 }
 video_channel_list[i][0]=0;


 /* set channel 0 by default and norm=0 */
  current_video_channel=0;
  vdc.channel=0;
  vdc.norm=0;
  ioctl(f,VIDIOCSCHAN,&vdc);
  ioctl(f,VIDIOCGCHAN,&vdc);
  if (vdc.flags & VIDEO_VC_TUNER)
  {
   vdt.tuner=0;  /* TV one tuner by channel ? */
   ioctl(f,VIDIOCGTUNER,&vdt);
   vdc.norm=vdt.mode;
   if (vdc.norm>3) vdc.norm=0;
   ioctl(f,VIDIOCSTUNER,&vdt);
  }
  ioctl(f,VIDIOCSCHAN,&vdc);

  
 /******************************Picture*******************************/
 rc = ioctl(f,VIDIOCGPICT,&vdp);
 if (rc!=0) { fprintf (stderr,"Can't VIDIOCGPICT \n"); return -1; }

 vdp.palette=PALETTE;
 vdp.depth=16;
 rc = ioctl(f,VIDIOCSPICT,&vdp);
 if (rc!=0) { fprintf (stderr,"Can't VIDIOCSPICT \n"); return -1; }
 else if (debug) { fprintf (stderr,"VIDIOCSPICT \n"); }

 memset(&vdw,0,sizeof(struct video_window));
 vdw.width=W;vdw.height=H;
 rc = ioctl(f,VIDIOCSWIN,&vdw);
 if (rc!=0) { fprintf (stderr,"Can't VIDIOCSWIN %d \n",rc); return -1; }
 else if (debug) {fprintf (stderr,"VIDIOCSWIN \n"); }


 /***************************  prepare for capture *******************/

 /* map grab buffer */

 rc=ioctl(f,VIDIOCGMBUF,&vdmb);
 if (debug) {
 fprintf(stderr,"Video buffer : Total size->%d  Numbers of frame->%d \n",vdmb.size,vdmb.frames);
 for (i=0;i<vdmb.frames;i++) fprintf(stderr,"Buffer %d Offset %x\n",i,vdmb.offsets[i]);
 }
 if (rc==0) {
 map = mmap(0,vdmb.size,PROT_READ|PROT_WRITE,MAP_SHARED,f,0);
 if (debug) fprintf(stderr,"Mmap\n");
 if ((char*)-1 == map){  fprintf(stderr,"ERROR mmap"); map=NULL; return -1; }
 /* allocation */
 NBWBUFF=vdmb.frames;

  gb = (struct video_mmap*) malloc (NBWBUFF*sizeof(struct video_mmap));
  if (gb==NULL) return -1;
 {
  int i;
  for (i=0;i<NBWBUFF;i++)
  {
   gb[i].frame  = i;
   gb[i].format = PALETTE;
   gb[i].width  = W;
   gb[i].height = H;
  }

  pmb = (struct pmb_s *) malloc (NBWBUFF*sizeof(struct pmb_s));
  if (pmb==NULL) return -1;

  trp = (struct trx_s *) malloc (NBWBUFF*sizeof(struct trx_s));
  if (trp==NULL) return -1;

  tri = (struct trx_s *) malloc (NBWBUFF*sizeof(struct trx_s));
  if (tri==NULL) return -1;
 }

 } else fprintf(stderr,"Can't VIDIOCGMBUF %d \n",rc);

 memset(map ,0,vdmb.size);

 return 0;
}

/************************************command stuff ********************************/

/*******************  Tuner *************************/

int set_tuner_norm(int norm){
 int rc;
 if (norm==-1) return 0;
 if (!(vdc.flags & VIDEO_VC_TUNER)) return -1;
 vdt.tuner=0;  /* TV one tuner by channel ? */
 rc = ioctl(f,VIDIOCGTUNER,&vdt);
 if (rc!=0) { if (debug) fprintf(stderr,"Can't VIDIOCGCTUNER Norm %d \n",rc); return -1; }
 else { if (debug) fprintf(stderr,"VIDIOCGTUNER\n"); }

 vdt.mode=norm;
 rc = ioctl(f,VIDIOCSTUNER,&vdt);
 if (rc!=0) { if (debug) fprintf(stderr,"Can't VIDIOCSTUNER %d \n",rc); return -1; }
 else { if (debug) fprintf(stderr,"VIDIOCSTUNER %d norm : %d\n",vdt.tuner,norm); }
 /* set channel capture norm */
 setnorm(norm);

 return 0;
}

int get_tuner_norm(int *norm){
 if (!(vdc.flags & VIDEO_VC_TUNER)) return -1;
 *norm = vdt.mode;
 return 0;
}

int setfreq(unsigned long freq){
 int rc;
 if (!(vdc.flags & VIDEO_VC_TUNER)) return -1;
 freq *=16;
 freq /=1000;
 rc = ioctl(f,VIDIOCSFREQ,&freq);
 if (rc!=0) { if (debug) fprintf(stderr,"Can't VIDIOCSFREQ\n"); return -1; }
 else if (debug) fprintf(stderr,"VIDIOCSFREQ %6.2f Mhz \n",(float) freq  / 16.0);

 return 0;
}

int getfreq(unsigned long *freq){
 int rc;
 if (!(vdc.flags & VIDEO_VC_TUNER)) return -1;
 rc= ioctl(f,VIDIOCGFREQ,freq);
 (*freq) = ((*freq) * 1000) / 16;
 if (rc!=0) { if (debug) fprintf(stderr,"Can't VIDIOCGFREQ\n"); return -1; }
 else if (debug) fprintf(stderr,"VIDIOCGFREQ %d Khz\n", (int) *freq);

 return *freq;
}

/************************** Source ******************/
int setsource(char *s){
 int i,rc;

/* search channel   */
 for (i=0; video_channel_list[i][0]!=0;i++)
   if (0 == strcmp(s,video_channel_list[i])) break;
 if (video_channel_list[i][0]==0) return -1;
 current_video_channel=i;
 /* get info */
 vdc.channel=i;
 rc = ioctl(f,VIDIOCGCHAN,&vdc);
 if (rc!=0) { if (debug) fprintf(stderr,"Can't VIDIOCGCHAN %d \n",rc); return -1; }
       else if (debug) fprintf(stderr,"VIDIOCGCHAN  \n");

 /* set channel */
 rc = ioctl(f,VIDIOCSCHAN,&vdc);
 if (rc!=0) { if (debug) fprintf(stderr,"Can't VIDIOCSCHAN Source %d \n",rc); return -1; }
 else if (debug) fprintf(stderr,"VIDIOCSCHAN Source %s\n",vdc.name);

 if ( vdc.flags & VIDEO_VC_AUDIO) {
 rc = ioctl(f,VIDIOCGAUDIO,&vda);
 if (rc!=0) { fprintf(stderr,"Can't VIDIOCGAUDIO %d \n",rc);return -1;}
 else if (debug) {fprintf(stderr,"VIDIOCGAUDIO \n"); }
 if (debug) {
               fprintf(stderr,"Audio:%d ",vda.audio);
               fprintf(stderr,"Name:%s ",vda.name);
               fprintf(stderr,"step:%d ",vda.step);
               fprintf(stderr,"mode:%d ",vda.mode);
               fprintf(stderr,"Volume:%x ",(int) vda.volume);
               fprintf(stderr,"flags:%x \n",(int) vda.flags);
 }

 if (vda.flags & VIDEO_AUDIO_MUTABLE)
 if (vda.flags & VIDEO_AUDIO_MUTE){
     if (debug) fprintf(stderr,"Audio mute --> unmute ");
     vda.flags  &= ~VIDEO_AUDIO_MUTE ;
     if (debug) fprintf(stderr,"flags:%x \n",(int) vda.flags);
 }

 if (vda.flags & VIDEO_AUDIO_VOLUME) vda.volume=0x7fff;

 rc = ioctl(f,VIDIOCSAUDIO,&vda);
 mute_sound = OFF;
 if (rc!=0) { fprintf(stderr,"Can't VIDIOCSAUDIO %d \n",rc); return -1; }
 else if (debug) {fprintf(stderr,"VIDIOCSAUDIO\n"); }
                                   }
 return 0;
}

int getsource(char **s){
     *s=vdc.name;
 return 0;
}

char *inc_source(void){
  current_video_channel++;
  if (video_channel_list[current_video_channel][0]==0)
     {
      current_video_channel--;
      return vdc.name;
     }
  setsource(video_channel_list[current_video_channel]);
  return vdc.name;
}

char *dec_source(void){
   current_video_channel--;
  if (current_video_channel<0)
     {
      current_video_channel++;
      return vdc.name;
     }
  setsource(video_channel_list[current_video_channel]);
  return vdc.name;
}

int setfreqtab(char *s){
   int i=0;
  while (chanlist_names[i].str!=NULL)
  if (strcmp(chanlist_names[i].str,s)==0) break; else i++;
  if (chanlist_names[i].str!=NULL) {
             chantab   = i;
             chanlist  = chanlists[chantab].list;
             chancount =  chanlists[chantab].count;
                                   } else return -1;

  return 0;
}

int getfreqtab(char **s){
    *s = ( char *) chanlist_names[chantab].str;
  return 0;
}

char *inc_freqtab(void){
  if (chanlist_names[chantab + 1].str!=NULL) {
                                               chantab ++;
                                               chanlist  = chanlists[chantab].list;
                                               chancount =  chanlists[chantab].count;
  }
  return  ( char *) chanlist_names[chantab].str;
}

char *dec_freqtab(void){
  if (chantab!=0) {
                    chantab --;
                    chanlist  = chanlists[chantab].list;
                    chancount =  chanlists[chantab].count;
  }
  return  ( char *) chanlist_names[chantab].str;
}

int setnorm(int norm){
 int rc;
 vdc.norm=norm;
 rc = ioctl(f,VIDIOCSCHAN,&vdc);
 if (rc!=0) { if (debug) fprintf(stderr,"Can't VIDIOCSCHAN Norm %d \n",rc); return -1; }
 else if (debug) fprintf(stderr,"VIDIOCSCHAN Norm %d\n",norm);
 pal=vdc.norm==VIDEO_MODE_PAL;
 if (rb) norm_changed=1;
 return 0;
}

int getnorm(int *norm){
   *norm = vdc.norm;
   return 0;
}

int inc_norm(void){
    if (vdc.norm<VIDEO_MODE_AUTO) setnorm(vdc.norm + 1);
    return vdc.norm;
}

int dec_norm(void){
    if (vdc.norm>VIDEO_MODE_PAL) setnorm(vdc.norm - 1);
    return vdc.norm;
}

char *get_norm_name(int norm){
     switch (norm) {
                    case VIDEO_MODE_PAL:
                         return "PAL";
                    break;
                    case VIDEO_MODE_NTSC:
                        return "NTSC";
                    break;
                    case VIDEO_MODE_SECAM:
                        return "SECAM";
                    break;
                    case VIDEO_MODE_AUTO:
                         return "AUTO";
                    break;
                    default:
                        return "?????";
                    break;
     }
}

char *get_norm_name2(int norm){
     switch (norm) {
                    case VIDEO_MODE_PAL:
                         return "pal";
                    break;
                    case VIDEO_MODE_NTSC:
                        return "ntsc";
                    break;
                    case VIDEO_MODE_SECAM:
                        return "secam";
                    break;
                    case VIDEO_MODE_AUTO:
                         return "auto";
                    break;
                    default:
                        return "?????";
                    break;
     }
}
/*****************************************Picture *****************************/

int setcapturesize(int w,int h)
{
 w_size=w; h_size=h;
 if (w_size<64) w_size=64;
 if (h_size<64) h_size=64;
 if (w_size>W ) w_size=W;
 if (h_size>H || decodeur) h_size=H;
 if (pal) {
            int i;
            pal_w_size = w_size + w_size*BURSTOFFSET/922;
            pal_w_size &= ~1;
            pal_xoffset = (pal_w_size - w_size) & ~2;
            pal_xoffset *=2;
            for (i=0;i<NBWBUFF;i++)
	    {
             gb[i].width  = pal_w_size;
             gb[i].height = h_size;
	    }
            init_translation();
           }
         else
           { int i;
             pal_xoffset =0;
             pal_w_size=w_size;
	     for (i=0;i<NBWBUFF;i++)
	     {
              gb[i].width  = w_size;
              gb[i].height = h_size;
	     }
             init_translation();
           }
 setbar();
 XDestroy_image();
 return XCreate_image();
}


int setcolour(int colour){
 int rc;
 vdp.colour=colour;
 rc = ioctl(f,VIDIOCSPICT,&vdp);
 if (rc!=0) { if (debug) fprintf (stderr,"Can't VIDIOCSPICT Color\n"); return -1; }
 else if (debug) { fprintf (stderr,"VIDIOCSPICT Color %d \n",colour); }

  return 0;
}

int getcolour(int *colour){
     *colour=vdp.colour;
    return 0;
}

int setbrightness(int brightness){
 int rc;
 vdp.brightness=brightness;
 rc = ioctl(f,VIDIOCSPICT,&vdp);
 if (rc!=0) { if (debug) fprintf (stderr,"Can't VIDIOCSPICT Brightness \n"); return -1; }
 else if (debug) { fprintf (stderr,"VIDIOCSPICT  Brightness %d \n",brightness); }
 return 0;
}

int getbrigthness(int *brightness){
    *brightness=vdp.brightness;
     return 0;
}

int setcontrast(int contrast){
 int rc;
 vdp.contrast=contrast;
 rc = ioctl(f,VIDIOCSPICT,&vdp);
 if (rc!=0) { if (debug) fprintf (stderr,"Can't VIDIOCSPICT Constrast \n"); return -1; }
 else if (debug) { fprintf (stderr,"VIDIOCSPICT Contrast %d \n",contrast); }

     return 0;
}

int getcontrast(int *contrast){
     *contrast=vdp.contrast;
    return 0;
}

int sethue(int hue){
 int rc;
 vdp.hue=hue;
 rc = ioctl(f,VIDIOCSPICT,&vdp);
 if (rc!=0) { if (debug) fprintf (stderr,"Can't VIDIOCSPICT Hue \n"); return -1; }
 else if (debug) { fprintf (stderr,"VIDIOCSPICT Hue %d \n",hue); }
     return 0;
}

int gethue(int *hue){
    *hue=vdp.hue;
      return 0;
}


/***********************TV CHANNEL**************************/
char * set_tv_channel_by_number (int n ){
      int i;
      char *s=_("No frequency channel");
      n--;
      if ( (n>=0) && (n<nbchaines)){
      /*** by freq ***/
         if (tv_channel_list[n].freq>0){
             s=tv_channel_list[n].name;
             setfreq((unsigned long) tv_channel_list[n].freq);
             set_tuner_norm( tv_channel_list[n].norm);
             cur_tv_channel=n+1;
             return s;
          }
      /*** by channel ***/
          for (i=0;i<chancount;i++)
              if (strcmp(chanlist[i].name,tv_channel_list[n].channel)==0) break;
              if (i<chancount) {
                                  s=tv_channel_list[n].name;
                                  setfreq((unsigned long) chanlist[i].freq);
                                  set_tuner_norm(tv_channel_list[n].norm);
                                  cur_tv_channel=n+1;
                               }
       }
       return s;
}

char *dec_tv_channel(void){
    char *s=_("No frequency channel");
    if (nbchaines==0) return s;
    cur_tv_channel--;
    if (cur_tv_channel==0) cur_tv_channel=nbchaines;
    return set_tv_channel_by_number (cur_tv_channel);
}

char *inc_tv_channel(void){
    char *s=_("No frequency channel");
    if (nbchaines==0) return s;
    cur_tv_channel++;
    if (cur_tv_channel>nbchaines) cur_tv_channel=1;
    return set_tv_channel_by_number (cur_tv_channel);
}

int set_last_tv_channel(){
      int tvc;
      tvc=load_last_channel();
      if (nbchaines==0) return -1;
      if (tvc>nbchaines) tvc=1;
      set_tv_channel_by_number (tvc);
      return 0;
}

char *get_current_tv_channel(int *n) {
 if (nbchaines==0) {
                       if (n!=NULL) *n=0;
                        return _("No channel");
 }
 if (n!=NULL) *n = cur_tv_channel;
 return tv_channel_list[cur_tv_channel - 1].name;
}

/********************* SOUND ****************************/

int toggle_mute_sound(){

if (mute_sound==ON)
     return set_mute_sound (OFF);
   else
     return set_mute_sound (ON);
 return 0;
}

int set_mute_sound (int flag) {
   int rc;

    if (vda.flags & VIDEO_AUDIO_MUTABLE){

     if  (flag==OFF) {
               vda.flags  &= ~VIDEO_AUDIO_MUTE ;
     } else {
               vda.flags  |=  VIDEO_AUDIO_MUTE ;
            }

     if (vda.flags & VIDEO_AUDIO_VOLUME) {
        if  (flag==OFF) vda.volume=0x7fff;
                   else vda.volume=0;
     }

     rc = ioctl(f,VIDIOCSAUDIO,&vda);

     if (rc!=0) {
                 if (debug) fprintf(stderr,"Can't VIDIOCSAUDIO mute \n");
                 return -1;
                } else
                 if (debug) { fprintf(stderr,"VIDIOCSAUDIO mute %d\n",flag); }

     if  (flag==OFF) mute_sound=OFF; else mute_sound=ON;

     return  mute_sound;
   }

  return -1;
}


int get_mute_sound (int *flag){
    *flag=mute_sound;
    return 0;
}

int toggle_sound_decoder_mode(){
  return set_sound_decoder_mode((decode_sound + 1) % 3);
}

int set_sound_decoder_mode(int flag){

     if (flag==OFF){
     if (decode_sound!=OFF) stop_nagraudio();
                       decode_sound=OFF;
                       return OFF;
                   }

     if (flag==ON) {
     if (decode_sound==OFF) start_nagraudio();
                              set_nagraudio_auto_mode(0);
                              decode_sound=ON;
                              return ON;

                   }

     if (flag==AUTO) {
     if (decode_sound==OFF)   start_nagraudio();
                              set_nagraudio_auto_mode(1);
                              decode_sound=AUTO;
                              return AUTO;
                     }
 return -1;
}

int get_sound_decoder_mode(int *flag){
    *flag=decode_sound;
   return 0;
}


char *get_char_sound_decoder_mode(void)
{
  char *tmp=NULL;
  int tmpi;

  get_sound_decoder_mode (&tmpi);
  if (tmpi==AUTO) tmp="auto";
  if (tmpi==ON)   tmp="on";
  if (tmpi==OFF)  tmp="off";
  return tmp;
}

/*************************Decoder command stuff ********************/

int set_decoder_mode (int flag){

     if (disable_decoding) return -1;

     if (flag==OFF) {
                     auto_decodeur=OFF;
                     if (rb) setcapturesize(wrw,wrh);
                     decodeur=OFF;
                     if (synchro_sound_video) set_sound_decoder_mode(OFF);
                     return OFF;
                     }

     if (flag==ON )  {
                       auto_decodeur=OFF;
                       decodeur=ON;
                       if (synchro_sound_video) set_sound_decoder_mode(ON);
                       if (rb) setcapturesize(wrw,H);
                       return ON;
                      }

      if (flag==AUTO) {
                       auto_decodeur=ON;
                       decodeur=ON;
                       if (synchro_sound_video) set_sound_decoder_mode(AUTO);
                       if (rb) setcapturesize(wrw,H);
                       return AUTO;
                      }

 return -1;
}

int toggle_decoder_mode (){

    if (disable_decoding) return -1;

    if (decodeur==OFF && auto_decodeur==ON)
        return set_decoder_mode (OFF);

    if (decodeur==OFF && auto_decodeur==OFF)
                return set_decoder_mode (ON);

    if (decodeur==ON && auto_decodeur==ON)
                return set_decoder_mode (OFF);

    if (decodeur==ON && auto_decodeur==OFF)
                return set_decoder_mode (AUTO);


  return -1;
}


int get_decoder_mode (int *flag) {

    if (disable_decoding) return -1;

    if (decodeur==OFF && auto_decodeur==ON)
        { *flag=AUTO; return 0;}

    if (decodeur==OFF && auto_decodeur==OFF)
        { *flag=OFF; return 0;}

    if (decodeur==ON && auto_decodeur==ON)
         { *flag=AUTO; return 0;}

    if (decodeur==ON && auto_decodeur==OFF)
            { *flag=ON; return 0;}

return -1;
}

char *get_char_decoder_mode (void)
{
  char *tmp=NULL;
  int tmpi;
  get_decoder_mode (&tmpi);
  if (tmpi==AUTO) tmp="auto";
  if (tmpi==ON)   tmp="on";
  if (tmpi==OFF)  tmp="off";
  return tmp;
}


int set_fast_quality_mode (int flag) {
 if (flag==ON) decode_trame_impaire=1;
         else
  decode_trame_impaire=sauve_decode_trame_impaire;
  flag_fast_quality = flag;
 return 0;
}

int toggle_quality_mode (){
    if (sauve_decode_trame_impaire==1)
                   return set_quality_mode (ON);
                 else
                   return set_quality_mode (OFF);
 return 0;
}

int set_quality_mode (int flag){
    if (flag==ON) {
    sauve_decode_trame_impaire=0;
                  }
      else
    sauve_decode_trame_impaire=1;
    if (flag_fast_quality == OFF)
             decode_trame_impaire=sauve_decode_trame_impaire;
    return flag;
}

int get_quality_mode ( int *flag){
    if (sauve_decode_trame_impaire==1) *flag=OFF; else *flag=ON;
    return 0;
}

char *get_char_quality_mode (void)
{
 char *tmp=NULL;
 if (sauve_decode_trame_impaire==1) tmp = "low"; else tmp = "high";
 return tmp;
}


int toggle_filter_mode () {
    if (filter==ON) return  set_filter_mode (OFF);
        else
                    return  set_filter_mode (ON);
  return 0;
}

int set_filter_mode (int flag) {
    filter=flag;
    return flag;
}


int get_filter_mode (int *flag) {
    *flag=filter;
   return 0;
}

char  *get_char_filter_mode (void){
 char *tmp=NULL;
 if (filter==ON) tmp = "on"; else tmp = "off";
 return tmp;
}

int set_synchro_decoder(int value)
{
 synchro_sound_video = value;
 return 0;
}

/********************************************************/
int end_video() {
  char *tmp=NULL;

 save_last_channel(&cur_tv_channel);

 open_config_file();

   tmp=get_char_decoder_mode ();
   save_config_value("decoder",tmp,AT_END);

   if (!disable_decoding)
   {
     tmp=char_get_couples();
     save_config_value("nbcouples",tmp,AT_END);
   }

   tmp=get_char_quality_mode ();
   save_config_value("quality",tmp,AT_END);

   tmp=get_char_filter_mode ();
   save_config_value("filter",tmp,AT_END);

   tmp=get_char_sound_decoder_mode ();
   save_config_value("decode_sound" ,tmp,AT_END);

   if (plug_decoder==0)
         save_config_value("decoder_in_use" ,"0",AT_END);
   else
         save_config_value("decoder_in_use" ,"1",AT_END);

   if (synchro_sound_video==0)
         save_config_value("synchro_sound" ,"0",AT_END);
   else
         save_config_value("synchro_sound" ,"1",AT_END);

 close_config_file();

 if (map!=NULL) munmap(map,vdmb.size);
 if (vda.flags & VIDEO_AUDIO_MUTABLE) vda.flags |= VIDEO_AUDIO_MUTE ;
 if (vda.flags & VIDEO_AUDIO_VOLUME) vda.volume=0;
 if (f!=-1) ioctl(f,VIDIOCSAUDIO,&vda);
 if (f!=-1) close (f);
 
 if (gb)  free(gb);
 if (pmb) free(pmb);
 if (trp) free(trp);
 if (tri) free(tri);

 end_kizkool32snabrab_filter ();

 return 0;
}



