/*************************************************************************
* video.h                                                                *
* Maupatz     2001                                                       *
* taztv is free software; you can redistribute it and/or modify          *
* it under the terms of the GNU General Public License as published by   *
* the Free Software Foundation; either version 2 of the License, or      *
* (at your option) any later version.                                    *
*                                                                        *
* Taztv is distributed in the hope that it will be useful,               *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
* GNU General Public License for more details.                           *
*                                                                        *
* You should have received a copy of the GNU General Public License      *
* along with this program; if not, write to the Free Software            *
*                                                                        *
*************************************************************************/

#ifndef VIDEO_H
#define VIDEO_H
int init_video (void);
int get_img_rb(void);

int setsource(char *s);
int getsource(char **s);
char *inc_source(void);
char *dec_source(void);
int setfreqtab(char *s);
int getfreqtab(char **s);
char *inc_freqtab(void);
char *dec_freqtab(void);
int setnorm(int norm);
int getnorm(int *norm);
int inc_norm(void);
int dec_norm(void);
char *get_norm_name(int norm);
char *get_norm_name2(int norm);
int setcolour(int colour);
int getcolour(int *colour);
int setbrightness(int brightness);
int getbrigthness(int *brightness);
int setcontrast(int contrast);
int getcontrast(int *contrast);
int sethue(int hue);
int gethue(int *hue);

int toggle_mute_sound(void);
int set_mute_sound (int flag);
int get_mute_sound (int *flag);
int toggle_sound_decoder_mode (void);
int set_sound_decoder_mode (int flag);
int get_sound_decoder_mode (int *flag);
char *get_char_sound_decoder_mode (void);

int get_tuner_norm(int *norm);
int set_tuner_norm(int norm);

char *set_tv_channel_by_number (int n);
char *inc_tv_channel(void);
char *dec_tv_channel(void);
char *get_current_tv_channel(int *n);
int set_last_tv_channel(void);

int end_video(void);

int set_decoder_mode (int flag);
int toggle_decoder_mode (void);
int get_decoder_mode (int *flag);
char *get_char_decoder_mode (void);

int toggle_quality_mode (void);
int set_quality_mode ( int flag);
int get_quality_mode ( int *flag);
char *get_char_quality_mode (void);
int set_fast_quality_mode (int flag);

int toggle_filter_mode (void);
int set_filter_mode (int flag);
int get_filter_mode (int *flag);
char  *get_char_filter_mode (void);

int set_plug_decoder(int value);
int set_synchro_decoder(int value);

int setcapturesize(int w, int h);

extern int decodeur;
extern int auto_decodeur;
extern int synchro_sound_video;
extern int filter;
extern int decode_sound;
extern int decode_trame_impaire;
extern int sauve_decode_trame_impaire;
extern int nbchaines;
extern int w_size;
extern int h_size;
extern int norm_changed;
extern char video_device[255];

#define NB_TV_CHANNEL_MAX 99
struct TV_CHANNEL {
                    char name[32];
                    char channel[32];
                    int freq;
                    int norm;

};

extern struct TV_CHANNEL tv_channel_list[NB_TV_CHANNEL_MAX];
extern char video_channel_list[16][32];

#endif
